/********************* (C) COPYRIGHT 2016 e-Design Co.,Ltd. ********************
 File Name : BIOS.h
 Version   : For DS211 Ver 1.6                                   Author : bure
*******************************************************************************/
#ifndef __BIOS_H
#define __BIOS_H

#include "stm32f10x_lib.h"

#define TYPE_DS211


//  void Ctrl(u8 Item, u32 Val)  Item ĶԼ Val ˵
//=====+========+========+========+========+========+========+========+========+
//Item:|ʱ|ģʽ|ģⶨʱ|ģ|ģ|ģƽ|״̬|ʱ
//-----+--------+--------+--------+--------+--------+--------+--------+--------+
// Val:|   mS   |   0~2  |  0~99  |   u16  |  u16*  |   u16  |   0~1  |   u16  |
//-----+--------+--------+--------+--------+--------+--------+--------+--------+
enum   {DELAYmS, OUT_MOD, DAC_TIM, OUT_CNT, OUT_BUF, OUT_VAN,  SMPL_ST, SMPLTIM,
//=====+========+========+========+========+========+========+========+========+
//Item:||| CHA| CHAƫ|Զػ
//-----+--------+--------+--------+--------+--------+--------+--------+--------+
// Val:|  u16*  |   u16  |   0~1  | 0~4095 |    0 
//-----+--------+--------+--------+--------+--------+--------+--------+--------+
         SMPLBUF, SMPLNUM, AiRANGE, AOFFSET, PWROFF, 
//=====+========+========+========+========+========+========+========+========+
};

//  void Ctrl(AiRANGE, AC+LV+ACT)  Val ͨ˵
//======+======================+=======================+=======================+
// Val: |      AC/DC       |     ѹ/ѹ     |     ӵ/ѹ     |
//------+----------------------+-----------------------+-----------------------+
enum    { AC = 0x00, DC = 0x02,  LV = 0x00,  HV = 0x01, GND = 0x00, ACT = 0x04,};
//======+======================+=======================+=======================+

// Info(u8 Item):Ӳ豸Ϣ
enum    { CHA_CNT, SIN_TAB, TRG_TAB, SAW_TAB };
//ͱʶ
enum    {LOW = 0, HIGH = 1, ANALOG = 2, PULSED = 4, SIMULTANEO = 5, INTERLEAVE = 6,};

extern vu8  Key_Buffer, Twink, Blink, Key_Status_Last;
extern vu16 Delay_Cnt, Tim_Cnt, PopupCnt;
extern u16  KEYTIME;

u16  Bat_Vol(void);
void Set_Range(u8 Range);
void Set_Base(u8 Base);
void ADC_Start(void);
u16  ADC_Cnt(u16 Value);
u8   USB_On(void);
char SD_Card_ON(void);
char KeyScan(void);
void Tim3_ISP(void);
void Set_Fout(u8 Range);
void Set_Duty(void);
void __Set_Posi(u16 x0, u16 y0);
void __Set_Pixel(u16 Color);
void __ClrScrn(u16 Color);
void __Display_Logo(u16 x0, u16 y0);
u8*  __DeviceInfo(u8 Device);
void __Ctrl(u8 Item, u32 Val);
void __Delay_mS(u32 mS);
u32  __Info(u8 Item);
void USB_Connect(u8 NewState);
void Power_Off(u8 State);
#endif

/*******************************  END OF FILE  ********************************/
