/******************** (C) COPYRIGHT 2012 e-Design Co.,Ltd. *********************
 File Name : HDW_Config.h
 Version   : DS211 Ver 1.6                                      Author : bure
*******************************************************************************/
#ifndef __HDW_CONFIG_H
#define __HDW_CONFIG_H

#include "stm32f10x_lib.h"
#include "STM32F10x.h"

#define Pwr_Off           GPIO_Pin_8 /*GPIO_B*/

//---------------------------- LCD ʾغ궨 ------------------------------

#define LCD_BL            GPIO_Pin_9 /*GPIO_B*/

#define LCD_nRD           GPIO_Pin_9  /*GPIO_C*/
#define LCD_nWR           GPIO_Pin_8  /*GPIO_A*/
#define LCD_RS            GPIO_Pin_9  /*GPIO_A*/
#define LCD_CS            GPIO_Pin_10 /*GPIO_A*/
#define LCD_nRST          GPIO_Pin_10 /*GPIO_B*/
#define LCD_DATA          GPIO_Pin_All/*GPIO_E*/

#define READ_LCD()        GPIOE->IDR                             
#define LCD_PORT_IN()     GPIOE->CRL  = GPIOE->CRH  = 0x44444444
#define LCD_PORT_OUT()    GPIOE->CRL  = GPIOE->CRH  = 0x33333333
#define LCD_nWR_ACT()     GPIOA->BSRR = GPIOA->BRR  = GPIO_Pin_8
#define LDC_DATA_OUT      GPIOE->ODR
#define LDC_DATA_INP      GPIOE->IDR

#define LCD_nRST_LOW()    GPIOB->BRR  = LCD_nRST
#define LCD_nRST_HIGH()   GPIOB->BSRR = LCD_nRST
#define LCD_RS_LOW()      GPIOA->BRR  = LCD_RS
#define LCD_RS_HIGH()     GPIOA->BSRR = LCD_RS
#define LCD_nRD_LOW()     GPIOC->BRR  = LCD_nRD
#define LCD_nRD_HIGH()    GPIOC->BSRR = LCD_nRD
#define LCD_nWR_LOW()     GPIOA->BRR  = LCD_nWR
#define LCD_nWR_HIGH()    GPIOA->BSRR = LCD_nWR

#define LCD_DAT_W(Data)   GPIOE->ODR  = Data;\
                          LCD_nWR_LOW();\
                          LCD_nWR_HIGH()
#define LCD_CMD_W(Cmd)    LCD_RS_LOW();\
                          LCD_DAT_W(Cmd);\
                          LCD_RS_HIGH()
                            
//------------------------------ KEY غ궨 --------------------------------

#define KEY_UP           GPIO_Pin_13  //GPIOD
#define KEY_DOWN         GPIO_Pin_15  //GPIOD
#define KEY_LEFT         GPIO_Pin_14  //GPIOD
#define KEY_RIGHT        GPIO_Pin_7   //GPIOC
#define KEY_PLAY         GPIO_Pin_12  //GPIOD
#define KEY_MENU         GPIO_Pin_6   //GPIOC

#define KEYCODE_VOID     0
#define KEYCODE_PLAY     1
#define KEYCODE_MANU     2
#define KEYCODE_UP       3
#define KEYCODE_DOWN     4
#define KEYCODE_LEFT     5
#define KEYCODE_RIGHT    6

#define KEYCODE_B        7
#define KEYCODE_ACT      8
#define KEYCODE_MEM      9
#define KEYCODE_D_MANU   10                            
                            
//--------------------------------궨 -------------------------------

#define DMA_CH_A         DMA1_Channel1

//------------------------------  ź궨 -------------------------------

#define TIM_DA           TIM7                            
#define OUT_ANALG        DAC->DHR12R1
#define OUT_DMA          DMA2_Channel4
                            
//--------------------------------ʱ궨 -------------------------------

#define TIM_AD           TIM1
#define TIM_AD_CCR       TIM_AD->CCR3

//-----------------------------CHAƫ غ궨 ------------------------------    
                            
#define DAC_PA           GPIO_Pin_5 /*GPIO_A*/
                            
//----------------------------- غ궨 -----------------------------    
                            
#define OUT_PO           GPIO_Pin_2 /*GPIO_A*/
#define OUT_AN           GPIO_Pin_4 /*GPIO_A*/                            
                            
//------------------------------ ѹ غ궨 -------------------------------
                            
#define V_BAT            GPIO_Pin_1 /*GPIO_A*/
#define V_USB            GPIO_Pin_0 /*GPIO_A*/
                            
//-------------------------- źͨغ궨 ----------------------------
#define SEL_AX           GPIO_Pin_0  /*GPIO_B*/
#define SEL_AY           GPIO_Pin_5  /*GPIO_C*/
#define SEL_AZ           GPIO_Pin_4  /*GPIO_C*/        

#define INP_AI0          GPIO_Pin_6  /*GPIO_A*/
#define INP_AI1          GPIO_Pin_7  /*GPIO_A*/                            
                            
#define AX_HIGH          GPIOB->BSRR = SEL_AX
#define AX_LOW           GPIOB->BRR  = SEL_AX
#define AY_HIGH          GPIOC->BSRR = SEL_AY
#define AY_LOW           GPIOC->BRR  = SEL_AY
#define AZ_HIGH          GPIOC->BSRR = SEL_AZ
#define AZ_LOW           GPIOC->BRR  = SEL_AZ                            

//------------------------------ Flash ռ --------------------------------

#define LOGO_BASE        ((u32)(0x0803D800)) // Size = 12KB
                            
//------------------------------ SPI غ궨 --------------------------------

#define SPIx              SPI2
#define SPI_RST           GPIO_Pin_11 /*GPIO_B*/
#define SPI_CS            GPIO_Pin_12 /*GPIO_B*/
#define SPI_SCK           GPIO_Pin_13 /*GPIO_B*/
#define SPI_MISO          GPIO_Pin_14 /*GPIO_B*/
#define SPI_MOSI          GPIO_Pin_15 /*GPIO_B*/

//------------------------------ USB غ궨 --------------------------------

#define USB_DN            GPIO_Pin_11 /*GPIO_A*/
#define USB_DP            GPIO_Pin_12 /*GPIO_A*/
#define SWD               GPIO_Pin_13 /*GPIO_A*/
#define SWC               GPIO_Pin_14 /*GPIO_A*/

//------------------------------ SCI غ궨 --------------------------------
                            
#define SCI_CLK_HIGH()    GPIOA->BSRR = USB_DN
#define SCI_CLK_LOW()     GPIOA->BRR  = USB_DN
#define SCI_DIO_HIGH()    GPIOA->CRH |= 0x00080000;\
                          GPIOA->CRH &= 0xFFF8FFFF
#define SCI_DIO_LOW()     GPIOA->CRH |= 0x00030000;\
                          GPIOA->CRH &= 0xFFF3FFFF;\
                          GPIOA->BRR  = USB_DP

#define AFIO_MAPR      (*((vu32 *)(AFIO_BASE+0x04)))

#define SCS_BASE       ((u32)0xE000E000)
#define SysTick_BASE   (SCS_BASE + 0x0010)
//============================ Ӳʼ ============================//

void Set_System(void);
void NVIC_Configuration(void);
void GPIO_Config(void);
void SPI_Config(void);

void DMA_Configuration(void);
void ADC_Configuration(void);
void Tim_Config(void);
void DAC_Config(void);

#endif
/****************************** END OF FILE ***********************************/
