/******************** (C) COPYRIGHT 2009 e-Design Co.,Ltd. *********************
* File Name: Files.c       DS211 Ver 1.6                          Author: xie
*******************************************************************************/
#include <stdlib.h>
#include "string.h"
#include "stm32f10x_lib.h"
#include "stm32f10x_flash.h"
#include "Draw.h"
#include "Func.h"
#include "File.h"
#include "FAT12.h"
#include "Menu.h"
#include "Process.h"
#include "Display.h"
#include "DFU_Func.h"
#include "Ext_Flash.h"
#include "Bios.h"

#define Page_Address    0x08007000
#define Kpg_Address     0x08007800  /*У׼Kpg[]ƫƺϵ */

u8*   NamePtr;
u32*  ViPtr;
s16   TIM_BASE_Val;
u8    Cal_Sta   = 1;
u8    Num[4];
u_64  Svg_Cnt = 0;
u32   Clk_Cnt = 0;
u16   Addr = 0, Length = 0;

extern u8 USB_FLAG;

uc16 CLK_TAB[44] =
  {0x000,0x000,0x000,0x000,0x070,0x3FF,0x070,0x000,0x000,0x000,0x000,
   0x000,0x002,0x004,0x008,0x070,0x070,0x070,0x080,0x100,0x200,0x000,
   0x020,0x020,0x020,0x020,0x070,0x070,0x070,0x020,0x020,0x020,0x020,
   0x000,0x200,0x100,0x080,0x070,0x070,0x070,0x008,0x004,0x002,0x000};

uc16 BMP_Color[16] = {WHT,  CYN, CYN_,  YEL,  YEL_, PUR, PUR_, GRN,
                      GRN_, GRY, ORN, BLU, RED, BLK, LGN,  DAR};

uc8  BmpHead[54]   = {0X42, 0X4D, 0X76, 0X96, 0X00, 0X00, 0X00, 0X00,
                      0X00, 0X00, 0X76, 0X00, 0X00, 0X00, 0X28, 0X00,
                      0X00, 0X00, 0X40, 0X01, 0X00, 0X00, 0XF0, 0X00,
                      0X00, 0X00, 0X01, 0X00, 0X04, 0X00, 0X00, 0X00,
                      0X00, 0X00, 0X82, 0X0B, 0X00, 0X00, 0X12, 0X0b,
                      0X00, 0X00, 0X12, 0X0b, 0X00, 0X00, 0X00, 0X00,
                      0X00, 0X00, 0X00, 0X00, 0X00, 0X00};

unsigned int DiskStart, Hidden_Sec, Root_Addr, ClusterNum, File_Addr;
unsigned short RsvdSecCnt, SectorSize, FAT_Size, FileLen;
unsigned short SecPerClus, DirFliePtr, DirSecNum, FAT1_Addr, FAT_Ptr;
unsigned char  F_Buff[4096+60],F_Sector[512];
u32* FilePtr;
/*******************************************************************************
Color_Num: ǰɫĶӦɫ
*******************************************************************************/
u8 Color_Num(u16 Color)
{
  if(Color == WHT)                  return 0;
  else if((Color & CYN  )== CYN  )  return 1;
  else if((Color & CYN_ )== CYN_ )  return 2;
  else if((Color & YEL  )== YEL  )  return 3;
  else if((Color & YEL_ )== YEL_ )  return 4;
  else if((Color & PUR  )== PUR  )  return 5;
  else if((Color & PUR_ )== PUR_ )  return 6;
  else if((Color & GRN  )== GRN  )  return 7;
  else if((Color & GRN_ )== GRN_ )  return 8;
  else if((Color & GRY  )== GRY  )  return 9;
  else if((Color & ORN  )== ORN  )  return 10;
  else if((Color & BLU  )== BLU  )  return 11;
  else if((Color & RED  )== RED  )  return 12;
  else if((Color & BLK  )== BLK  )  return 13;
  else if((Color & LGN  )== LGN  )  return 14;
  else                              return 15;
}
/*******************************************************************************
 ָչļ            룺ļչ             ֵ0x00=ɹ
*******************************************************************************/
void Make_Filename(s16 FileNo,unsigned char* FileName)
{
  u8 Num[4];
  u8ToDec3(Num, FileNo);
  FileName[4] = Num[0];
  FileName[5] = Num[1];
  FileName[6] = Num[2];
}
/*******************************************************************************
Load_File_Num(u8 Tpye)   룺ļ     ֵļ
*******************************************************************************/
s16 Load_File_Num(u8 Tpye)
{
  s16 FileNo=0;
  u8  pFileName[12]="FILE       ";
  u16 pCluster[3];
  u32 pDirAddr[1];
  
  switch(Tpye)
  {
  case SAVE_BMP:
    memset(F_Buff,0,4096);
    memcpy(pFileName,"IMG_    BMP",12);
    Make_Filename(FileNo, pFileName);
    while(OpenFileRd(F_Buff, pFileName, pCluster, pDirAddr)==OK) {
      FileNo++;
      Make_Filename(FileNo, pFileName);
    }
    break;
  case SAVE_DAT:
    memset(F_Buff,0,4096);
    memcpy(pFileName,"FILE    DAT",12);
    Make_Filename(FileNo, pFileName);
    while(OpenFileRd(F_Buff, pFileName, pCluster, pDirAddr)==OK) {
      FileNo++;
      Make_Filename(FileNo, pFileName);
    }
    break;
  case SAVE_BUF:
    memset(F_Buff,0,4096);
    memcpy(pFileName,"DATA    BUF",12);
    Make_Filename(FileNo, pFileName);
    while(OpenFileRd(F_Buff, pFileName, pCluster, pDirAddr)==OK) {
      FileNo++;
      Make_Filename(FileNo, pFileName);
    }
    break;
  case SAVE_CSV:
    memset(F_Buff,0,4096);
    memcpy(pFileName,"DATA    CSV",12);
    Make_Filename(FileNo, pFileName);
    while(OpenFileRd(F_Buff, pFileName, pCluster, pDirAddr)==OK) {
      FileNo++;
      Make_Filename(FileNo, pFileName);
    }
    break;
  case SAVE_SVG:
    memset(F_Buff,0,4096);
    memcpy(pFileName,"DATA    SVG",12);
    Make_Filename(FileNo, pFileName);
    while(OpenFileRd(F_Buff, pFileName, pCluster, pDirAddr)==OK) {
      FileNo++;
      Make_Filename(FileNo, pFileName);
    }
    break;
  }
  return FileNo;
}
/*******************************************************************************
void File_Num(void)   룺ļ     ֵļ
*******************************************************************************/
void File_Num(void)   
{
  List[SAVE_BMP].Val =  Load_File_Num(SAVE_BMP);
  List[SAVE_DAT].Val =  Load_File_Num(SAVE_DAT);
  List[SAVE_BUF].Val =  Load_File_Num(SAVE_BUF);
  List[SAVE_CSV].Val =  Load_File_Num(SAVE_CSV);
  List[SAVE_SVG].Val =  Load_File_Num(SAVE_SVG);
} 
/*******************************************************************************
Save_Dat: 浱ǰĻʾͼԭʼ    룺ļ     ֵ0x00=ɹ
*******************************************************************************/
u8 Save_Dat(s16 FileNo)
{
  u8 pFileName[12]="FILE    DAT";
  u16 Rvalue=DISK_RW_ERR ;
  u16 pCluster[3];
  u32 pDirAddr[1];
  Make_Filename(FileNo, pFileName);
  memset(F_Buff,0,4096);
  if(OpenFileWr(F_Buff, pFileName, pCluster, pDirAddr)!=OK) return Rvalue;
  F_Buff[0]  = 1;              //Ver0001
  F_Buff[1]  = List[V0_POSI].Val;
  F_Buff[2]  = List[EXT_POSI].Val;
  F_Buff[3]  = List[TIM_BASE].Val;
  F_Buff[4]  = List[Y_RANGES].Val;
  F_Buff[5]  = List[COUPLING].Val;
  F_Buff[6]  = List[PROBEATT].Val;
  F_Buff[7]  = List[TR_MODE].Val;
  
  memcpy(&F_Buff[10], WaveBuf, 300); 
  if(ProgFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR; // д
  if(CloseFile(F_Buff, 512, pCluster, pDirAddr)!= OK) return FILE_RW_ERR;
  if(List[SAVE_DAT].Val<99)List[SAVE_DAT].Val++;
  return OK;
}
/*******************************************************************************
Load_Dat: رĻͼԭʼ    룺ļ     ֵ0x00=ɹ
*******************************************************************************/
u8 Load_Dat(s16 FileNo)
{
  u8 pFileName[12]="FILE    DAT";
  u16 pCluster[3];
  u32 pDirAddr[1];
  u16  Rvalue=0;
  int i;
  
  Make_Filename(FileNo, pFileName);
  if((Rvalue=OpenFileRd(F_Buff, pFileName, pCluster, pDirAddr))!= OK) return Rvalue;
  if(ReadFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR;
  memcpy(Data, F_Buff, 310);

  List[TIM_BASE].Val = F_Buff[3];
  List[Y_RANGES].Val = F_Buff[4];
  List[COUPLING].Val = F_Buff[5];
  List[PROBEATT].Val = F_Buff[6];
  List[TR_MODE].Val  = F_Buff[7];
  
  for(i=0;i<4;i++)List[i].Flg |= UPD;  
  List[EXT_REFN].Flg |= UPD; 
  List[EXT_POSI].Flg |= UPD; 
  List[TIM_BASE].Flg |= UPD;
  List[TR_MODE].Flg |= UPD;
  Update_Detail();
  if(List[LOAD_DAT].Val<99)List[LOAD_DAT].Val++;
  return OK;
}

/*******************************************************************************
Save_Bmp: 浱ǰĻʾͼΪBMPʽ    룺ļ     ֵ0x00=ɹ
*******************************************************************************/
u8 Save_Bmp(s16 FileNo)
{	
  u8  pFileName[12]="IMG_    BMP";
  u16 pCluster[3];
  u32 pDirAddr[1];
  u32 Rvalue=DISK_RW_ERR;
  s16 x, y, i=54, j,ColorH,ColorL ;
  u16 k=0, l=0;
  u32 length;
  
  if(flash_mode==FLASH_8M)length=4096;
  else length=512;
  
  USB_Connect(DISABLE);
  
  if(Current == FN){
    Close_Pop();
    __DrawWindow(WaveBuf, ParamTab);
  }
  Make_Filename(FileNo, pFileName);
  if(OpenFileWr(F_Buff, pFileName, pCluster, pDirAddr)!=OK) return Rvalue;
  memcpy(F_Buff, BmpHead, 54);
  i = 0x0036;                                     // ɫſʼַ
  for(j=0; j<16; ++j){
    F_Buff[j*4 +i+0]=(BMP_Color[j] & 0xF800)>>8;  // Bule
    F_Buff[j*4 +i+1]=(BMP_Color[j] & 0x07E0)>>3;  // Green&
    F_Buff[j*4 +i+2]=(BMP_Color[j] & 0x001F)<<3;  // Red
    F_Buff[j*4 +i+3]= 0;                          // Alpha
  }
  i = 0x0076;                                     // ͼݿʼŵַ
  for(y=0; y<240; y++){
    for(x=0; x<320 ; x+=2){
      __Set_Posi(x, y); 
      ColorH = __Get_Pixel();
      __Set_Posi(x+1, y); 
      ColorL = __Get_Pixel();
      F_Buff[i] =(Color_Num(ColorH)<<4)+ Color_Num(ColorL);
      i++;
      if(i>=length){
        i=0;
        if(ProgFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR; // д
        if(l==0)PrintClk(168,2,(k++ >>1)& 3);         // ָʾ
        l++;
        if(l>=2)l=0;
      }
    }
  }
  if(i!=0){
      if(ProgFileSec(F_Buff, pCluster)!= OK){List_Pop();return FILE_RW_ERR;} // д
    }
  if(CloseFile(F_Buff, 76*512, pCluster, pDirAddr)!= OK) return FILE_RW_ERR;
  if(Current == FN)List_Pop();
  if(List[SAVE_BMP].Val<99)List[SAVE_BMP].Val++;
  
  USB_Connect(ENABLE);
  return OK;
}
/*******************************************************************************
Save_Buf: ɼݻΪBUFʽ    룺ļ     ֵ0x00=ɹ
*******************************************************************************/
u8 Save_Buf(s16 FileNo)
{
  u8 pFileName[12]="DATA    BUF";
  u16 pCluster[3];
  u32 pDirAddr[1];
  u32 i=0, Rvalue=DISK_RW_ERR;
  u16 *p;
  u8  l=0;
  u16 n,k;
  
   n=2; k=4096;
   
  if(List[SMPL_DPTH].Val==3) n =4 ;//8K 
   
  Make_Filename(FileNo, pFileName);
  memset(F_Buff,0,4096);
  if(OpenFileWr(F_Buff, pFileName, pCluster, pDirAddr)!=OK) return Rvalue;

  for(i=0; i<n; i++){
    memcpy(F_Buff,&(Sampl[i*k/2+2]),k);
    if(ProgFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR; // д
    PrintClk(264,2,(l++ >>1) & 3);                    // ָʾ
  }
  memset(F_Buff,0,k);
  p =(u16*)&F_Buff;
  *p++=Sampl[0];
  *p++=Sampl[1];
  *p++=List[Y_RANGES].Val;
  *p++=List[PROBEATT].Val;
  *p++=List[SMPL_DPTH].Val;
  if(ProgFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR; // д
  if(CloseFile(F_Buff, 16*512+k, pCluster, pDirAddr)!= OK) return FILE_RW_ERR;
  if(List[SAVE_BUF].Val<99)List[SAVE_BUF].Val++;
  return OK;
}
/*******************************************************************************
Restore_Scene: زɼݻʱƻֳָʱֳָ
*******************************************************************************/
void Restore_Scene(void)
{ 
  u16 *ptr;

  ptr=(u16*)F_Sector;
  *ptr++=0x0;
  Sampl[0]=*ptr++;
  Sampl[1]=*ptr++;
  List[Y_RANGES].Val=*ptr++;
  List[PROBEATT].Val=*ptr++;
  List[SMPL_DPTH].Val=*ptr++;
}
/*******************************************************************************
Load_Buf: رĲɼݻ    룺ļ     ֵ0x00=ɹ
*******************************************************************************/
u8 Load_Buf(s16 FileNo)
{
  u8 pFileName[12]="DATA    BUF";
  u16 pCluster[3];
  u32 pDirAddr[1];
  u16 *ptr;
  u32 i,Rvalue=1;
  u32 n,k;

  Make_Filename(FileNo, pFileName);
  if( (Rvalue=OpenFileRd(F_Buff, pFileName, pCluster, pDirAddr))!= OK) return Rvalue;
  if(flash_mode==FLASH_8M){
    n=2;k=4096;
  }else{
    n=16;k=512;
  }
  if(List[SMPL_DPTH].Val==3) n =4 ;//8K 
  for(i=0;i<n;i++){
    if(ReadFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR;
    memcpy(&(Sampl[i*k/2+2]),F_Buff,k);
	}
  if(ReadFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR;
  ptr=(u16*)F_Sector;                               //ֳ
  *ptr++=0xaa55;
  *ptr++=Sampl[0];
  *ptr++=Sampl[1];
  *ptr++=List[Y_RANGES].Val;
  *ptr++=List[PROBEATT].Val;
  *ptr++=List[SMPL_DPTH].Val;			
  ptr =(u16*)F_Buff;                            //ԭĲ
  Sampl[0]=*ptr++;
  Sampl[1]=*ptr++;
  List[Y_RANGES].Val=*ptr++;
  List[PROBEATT].Val=*ptr++;
  List[SMPL_DPTH].Val=*ptr++;
  Status |=  STOP;
  DispStatus();
  if(List[LOAD_BUF].Val<99)List[LOAD_BUF].Val++;
  return 0;
}
//------------------------------------------------------------------
void make_Vertical(u8* buf,u8* len)
{
  u8 i=0;
  u8* ptr;

  ptr=(u8*)&R[List[Y_RANGES].Val];
  while(*ptr != 0)buf[i++] = *ptr++;
  buf[i++]   = 0x2a;
  ptr=(u8*)&N[List[PROBEATT].Val];
  while(*ptr != 0)buf[i++] = *ptr++;
  buf[i]   = 0x2c;
  buf[i+1] = 0;
  *len = i+1;
}
/*******************************************************************************
Save_Csv: ɼݻΪCSVʽ    룺ļ     ֵ0x00=ɹ
*******************************************************************************/
u8 Save_Csv(s16 FileNo)
{
  
  s32 Ak = (KgA[KindA+(StateA?1:0)]*4)/GK[GainA];
  
  u8 pFileName[12]="DATA    CSV";
  u16 pCluster[3];
  u32 pDirAddr[1];
  u32 i,k=0,l=0,Rvalue=DISK_RW_ERR,length;
  u8 Num[4],track[4];
  s16 temp;
  u8 count;
  
  if(flash_mode==FLASH_8M)
    length=4096;
  else
    length=512;
 
  Make_Filename(FileNo, pFileName);
  if(OpenFileWr(F_Buff, pFileName, pCluster, pDirAddr)!=OK) return Rvalue;
  memcpy(&F_Buff[0],TimeBase_Str[List[TIM_BASE].Val],5);
  memcpy(&F_Buff[5],"   ",3);
  make_Vertical(&F_Buff[8],&count);
  k=8+count;
  memcpy(&F_Buff[k],"\r\n",2);
  k+=2;
  for(i=0; i<DEPTH[List[SMPL_DPTH].Val]; i++){
    
    temp = ((((Sampl[2+i])-2048)*Ak)>>12)+100;  
    
    if(temp > 0){
      if(temp > 200)  track[0] = 199;
      else            track[0] = temp;
    } else            track[0] = 0;
    u8ToDec3(Num,track[0]);
    for(count=0; count<3; count++){
      if(Num[count] == 0) break;
      F_Buff[k++] = Num[count];
      if(k >= length){
        if(ProgFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR; // д
        PrintClk(264,2,(l++ >>1) & 3);                    // ָʾ
        k = 0;
      }
    }
    F_Buff[k++] = 0x2c;
    if(k >= length){
      if(ProgFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR; // д
      PrintClk(264,2,(l++ >>1)& 3);                    // ָʾ
      k = 0;
    }
    F_Buff[k++] = 0x0d;
    if(k >= length){
      if(ProgFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR; // д
      PrintClk(264,2,(l++ >>1)& 3);                    // ָʾ
      k = 0;
    }
    F_Buff[k++] = 0x0a;
    if(k >= length){
      if(ProgFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR; // д
      PrintClk(264,2,(l++ >>1)& 3);                    // ָʾ
      k = 0;
    }
  }
  if(k != 0){
    F_Buff[k++]=0x0d;
    F_Buff[k++]=0x0a;
    memset(&F_Buff[k],32,(4096-k)); //32->ո
    k=0;
    if(ProgFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR; // д
    PrintClk(264,2,(l++ >>1)& 3);                     // ָʾ
  }
  if(CloseFile(F_Buff, l*length, pCluster, pDirAddr)!= OK) return DISK_RW_ERR;
  if(List[SAVE_CSV].Val<99)List[SAVE_CSV].Val++;
  return OK;
}
/*******************************************************************************
Save_Svg: ɼݻΪBUFʽ    룺ļ     ֵ0x00=ɹ
*******************************************************************************/
u8 Save_Svg(s16 FileNo)
{
  u8 pFileName[12]="DATA    SVG";
  u16 pCluster[3];
  u32 pDirAddr[1];
  u16 track[4];
  u32 Rvalue = DISK_RW_ERR; 
  u32 l = 0;
  u16 Buf_len = 4096;
  u16 i,x, y;
  s16 temp;
  u8  *str;
  s16 Posi1 = 0;
  s32 Ak = (KgA[KindA+(StateA?1:0)]*4)/GK[GainA];
 
  
  Svg_Cnt = 0;
  Addr = 0, Length = 0;
  str = (u8*)&Data;
  //__USB_Port(DISABLE);
  memset(Data,0,310);
  memset(F_Buff,0,Buf_len);
  Make_Filename(FileNo, pFileName);
  if(OpenFileWr(F_Buff, pFileName, pCluster, pDirAddr)!=OK) return Rvalue;
  //SVG ĵĳЩSVG ,ָⲿDTD
  str = "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n";
  WriteStr(str, pCluster);
  str = "<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.0//EN\" \"http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd\">\n";
  WriteStr(str, pCluster);
  str = "<svg width=\"";
  WriteStr(str, pCluster);
  WriteVar(DEPTH[List[SMPL_DPTH].Val], pCluster);
  str = "\" height=\"200\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" onload=\"init(evt)\" onmousemove=\"msMove(evt)\">\n";
  WriteStr(str, pCluster);
  
  //Сɫ
  str = "<path stroke=\"none\" fill=\"black\" d=\"M0,0 H";
  WriteStr(str, pCluster);  
  WriteVar(DEPTH[List[SMPL_DPTH].Val], pCluster);
  str = " V200 H0 V0\"/>\n";
  WriteStr(str, pCluster);
  //ǰڱ
  str = "<path stroke=\"none\" fill=\"#400040\" d=\"M";  //ɫ
  WriteStr(str, pCluster);
  WriteVar(List[VIEWPOSI].Val, pCluster);
  str = ",0 H";
  WriteStr(str, pCluster);
  WriteVar(List[VIEWPOSI].Val, pCluster);  
  str = " V200 H";
  WriteStr(str, pCluster);
  WriteVar(List[VIEWPOSI].Val+300, pCluster);
  str = "  V0\"/>\n";
  WriteStr(str, pCluster);
  //
 for (y=0; y<=200; y+=25){
    //<path stroke="#404040" d="M0,0 H4096"/>
    str = "<path stroke=\"#404040\" d=\"M0,";
    WriteStr(str, pCluster);
    WriteVar(y, pCluster);
    str = " H";
    WriteStr(str, pCluster);
    WriteVar(DEPTH[List[SMPL_DPTH].Val], pCluster); 
    str = "\"/>\n";
    WriteStr(str, pCluster);
  }
  for (x=0; x<=DEPTH[List[SMPL_DPTH].Val]; x+=25){
    //<path stroke="#404040" d="M0,0 V256"/>
    str = "<path stroke=\"#404040\" d=\"M";
    WriteStr(str, pCluster);
    WriteVar(x, pCluster);
    str = ",0 V200\"/>\n";
    WriteStr(str, pCluster);
  }
  //ͨA
  str = "<path stroke=\"cyan\" fill=\"none\" stroke-width=\"1\" d=\"";
  WriteStr(str, pCluster);
  for (i=0; i<=DEPTH[List[SMPL_DPTH].Val]; i++){
      temp = ((((Sampl[2+i])-2048)*Ak)>>12)+100;          
    if(temp > 0){
      if(temp > 200)  track[0] = 199;
      else            track[0] = temp;
    } else            track[0] = 0; 
    track[0] =  200- track[0];     
    if(i==0)str = "M";
    else    str = " L";
    WriteStr(str, pCluster);
    WriteVar(i, pCluster);
    str = ",";
    WriteStr(str, pCluster);
    WriteVar(track[0], pCluster);
  }
  str = "\"/>\n";
  WriteStr(str, pCluster);

  //Ҷ˵λʱ
  str = "<text font-family=\"Arial\" x=\"638\" y=\"170\" fill=\"cyan\" font-size=\"18\" text-anchor=\"end\" id=\"CH1s\">CH1: ";
  WriteStr(str, pCluster);
  if(List[PROBEATT].Val)str = (u8*)Vol_10X[List[Y_RANGES].Val];
  else                         str = (u8*)Vol_Str[List[Y_RANGES].Val];
  WriteStr(str, pCluster);
  str = "/div ";
  WriteStr(str, pCluster);
  str = "(";               
  WriteStr(str, pCluster);
  if(List[PROBEATT].Val)str = "X10";        //X10
  else                         str = "X1";  //X1
  WriteStr(str, pCluster);
  str = ") ";           
  WriteStr(str, pCluster);
  str = (u8*)TimeBase_Str[List[TIM_BASE].Val]; //Timebase
  WriteStr(str, pCluster);
  str = "/div</text>\n";
  WriteStr(str, pCluster);
  str = "<text font-family=\"Arial\" x=\"2\" y=\"170\" fill=\"cyan\" font-size=\"18\" text-anchor=\"start\" id=\"CH1\"> </text>\n";
  WriteStr(str, pCluster);
 //===============================
  //
  Posi1 = 199-List[V0_POSI].Val;
  //===============================
  str = "<script type=\"text/ecmascript\"><![CDATA[\n";
  WriteStr(str, pCluster);
  str = "function init(evt) { if ( window.svgDocument == null ) svgDocument = evt.target.ownerDocument; }\n";
  WriteStr(str, pCluster);
  str = "function fmtT(val, div) {\n";
  WriteStr(str, pCluster);
  str = "if (div > 10000) return Math.floor(val*div/25/1000) + \" ms\";\n";
  WriteStr(str, pCluster);
  str = "if (div > 250) return Math.floor(val*div/25)/1000 + \" ms\";\n";
  WriteStr(str, pCluster);
  str = "return Math.floor(val*div*1000/25)/1000 + \" us\";\n";
  WriteStr(str, pCluster);
  str = "}\n";
  WriteStr(str, pCluster);
  str = "function fmtU(val, div, shift) { return Math.floor((shift-val)*div/25) + \" mV\"; }\n";
  WriteStr(str, pCluster);
  str = "function msMove (evt)\n";
  WriteStr(str, pCluster);
  str = "{\n";
  WriteStr(str, pCluster);
  str = "var x = evt.pageX;\n";
  WriteStr(str, pCluster);
  str = "var y = evt.clientY;\n";
  WriteStr(str, pCluster);
  str = "if (x < 0 || y < 0 || x >= ";
  WriteStr(str, pCluster);
  WriteVar(DEPTH[List[SMPL_DPTH].Val], pCluster);
  str = "|| y >= 200)\n";
  WriteStr(str, pCluster);
  str = "return;\n";
  WriteStr(str, pCluster);
  str = "var hscroll = (document.all ? document.scrollLeft : window.pageXOffset);\n";
  WriteStr(str, pCluster);
  str = "var width = window.innerWidth;\n";
  WriteStr(str, pCluster);
  str = "\n";
  WriteStr(str, pCluster);
  str = "svgDocument.getElementById(\"CH1\").setAttribute(\"x\", hscroll+20);\n";
  WriteStr(str, pCluster);
  str = "svgDocument.getElementById(\"CH1s\").setAttribute(\"x\", hscroll+width-20);\n";
  WriteStr(str, pCluster);
  str = "\n";
  WriteStr(str, pCluster);
  //==============================
  str = "svgDocument.getElementById(\"CH1\").firstChild.data = \"CH1: \"+fmtU(y, ";
  WriteStr(str, pCluster);    
  if(List[PROBEATT].Val)str = (u8*)VScale_Str_10X[List[Y_RANGES].Val]; 
  else str = (u8*)VScale_Str[List[Y_RANGES].Val]; 
  WriteStr(str, pCluster);
  str = ", ";
  WriteStr(str, pCluster);
  WriteVar((u16)Posi1, pCluster); 
  str = ") + \" \" + fmtT(x, ";
  WriteStr(str, pCluster);
  str = (u8*)TScale_Str[List[TIM_BASE].Val]; //Timebase
  WriteStr(str, pCluster);        
  str = ");\n";
  WriteStr(str, pCluster);
  
  //==============================
  str = "}\n";
  WriteStr(str, pCluster);
  str = "]]></script>\n";
  WriteStr(str, pCluster);
  str = "</svg>\n";
  WriteStr(str, pCluster);
  if(ProgFileSec(F_Buff, pCluster)!= OK) return FILE_RW_ERR; // д
  PrintClk(264,2,(l++ >>1)& 3);                               // ָʾ
 
  if(CloseFile(F_Buff, Svg_Cnt, pCluster, pDirAddr)!= OK) 
    return DISK_RW_ERR;
  if(List[SAVE_SVG].Val<99)List[SAVE_SVG].Val++;
  //__USB_Port(ENABLE);
  memset(Data,0,310);
  return OK;
}
/*******************************************************************************
 WriteStr                   
*******************************************************************************/
void WriteStr(u8* Str, u16* pClu)
  {
    u16 temp_addr,temp_len;
    u16 Buf_len = 4096;  
    
    Length = strlen((char const*)Str);
    memcpy(&F_Buff[Addr], Str, Length);
    Addr = Addr + Length;
    Svg_Cnt = Svg_Cnt+ Length;
    if(Addr >=Buf_len){
      if(ProgFileSec(F_Buff, pClu)!= OK) {}; // д
      PrintClk(264,2,(Clk_Cnt++ >>1)& 3);     // ָʾ
      temp_len = Addr -Buf_len;
      temp_addr = Length - temp_len;
      Addr = 0;
      memset(F_Buff,0,Buf_len);
      memset(Data,0,310);
      memcpy(&F_Buff[Addr],Str + temp_addr, temp_len);
      Addr = Addr + temp_len;
      Length = 0;
    }
  }
/*******************************************************************************
 WriteVar                   
*******************************************************************************/
void WriteVar(u16 Var, u16* pClu)
  {
    u16 temp_addr,temp_len;
    u16 Buf_len = 4096; 
    
    memset(Num, 0, 4);
    u16ToDec4Str(Num,Var);
    Length = strlen((char const*)Num);
    memcpy(&F_Buff[Addr], Num, Length);
    Addr = Addr + Length;
    Svg_Cnt = Svg_Cnt+ Length;
    if(Addr >=Buf_len){
      if(ProgFileSec(F_Buff, pClu)!= OK) {}; // д
      //PrintClk(264,2,(Clk_Cnt++ >>1)& 3);  // ָʾ
      temp_len = Addr -Buf_len;
      temp_addr = Length - temp_len;
      Addr = 0;
      memset(F_Buff,0,Buf_len);
      memset(Data,0,310);
      memcpy(&F_Buff[Addr],Num + temp_addr, temp_len);
      Addr = Addr + temp_len;
      Length = 0;
    }
  }
/*******************************************************************************
 WriteVar_u64                   
*******************************************************************************/
void WriteVar_u64(u_64 Var, u16* pClu)
  {
    u16 temp_addr,temp_len;
    u16 Buf_len = 4096; 
    
    memset(Num, 0, 4);
    u16ToDec4Str(Num,Var);
    Length = strlen((char const*)Num);
    memcpy(&F_Buff[Addr], Num, Length);
    Addr = Addr + Length;
    Svg_Cnt = Svg_Cnt+ Length;
    if(Addr >=Buf_len){
      if(ProgFileSec(F_Buff, pClu)!= OK) {}; // д
      temp_len = Addr -Buf_len;
      temp_addr = Length - temp_len;
      Addr = 0;
      memset(F_Buff,0,Buf_len);
      memset(Data,0,310);
      memcpy(&F_Buff[Addr],Num + temp_addr, temp_len);
      Addr = Addr + temp_len;
      Length = 0;
    }
  }
/*******************************************************************************
 Save_Parameter: 浱ǰĹ                          Return: 0= Success
*******************************************************************************/
char Save_Parameter(void)
{
  unsigned short i, j;
  u16* ptr;

  FLASH_Unlock();
  j=FLASH_ErasePage(Page_Address);
  if(j== FLASH_COMPLETE){
    ptr=(u16*)&F_Buff;
    *ptr++=0x0400;                              //Ver:4.00
    *ptr++=Current;
    *ptr++=Status;
    for(i=0;i<44;i++) *ptr++=List[i].Val;
    for(i=0;i<8;i++)  *ptr++=MenuNow[i];
    *ptr++=0xaa55;
    ptr=(u16*)&F_Buff;
    for(i=0; i<256; i+=2){                      //128 SHORT
      j= FLASH_ProgramHalfWord(Page_Address+i, *ptr++);
      if(j!= FLASH_COMPLETE) break;
    }
  }
  FLASH_Lock();
  
  return j;
}
/*******************************************************************************
Read_Parameter: FLASH
*******************************************************************************/
void Read_Parameter(void)
{
  u8 i;
  u16* ptr;
  ptr=(u16*)(Page_Address+55*2); //94*2-40
  TIM_BASE_Val=List[TIM_BASE].Val;
  List[TIM_BASE].Val=0;
  if(*ptr!=0xaa55) return ;
  ptr=(u16*)Page_Address;
  if(*ptr++!=0x0400) return ;
  Current=*ptr++;
  List[MenuNow[Current]].Flg |= UPD;
  ptr++;
  for(i=0;i<44;i++) List[i].Val=*ptr++;
  for(i=0;i<8;i++)  MenuNow[i]=*ptr++;
  TIM_BASE_Val=List[TIM_BASE].Val;
  List[TIM_BASE].Val=0;

  return ;
}
/*******************************************************************************
 Save_Kpg: У׼                          Return: 0= Success
*******************************************************************************/
u8 Save_Kpg(void)
{
  unsigned short i, j;
  u16* ptr;

  FLASH_Unlock();
  j=FLASH_ErasePage(Kpg_Address);
  if(j== FLASH_COMPLETE){
    ptr=(u16*)&F_Buff;
    *ptr++=0xaa55;
    *ptr++=0x0400;                              //Ver:3.00
    *ptr++=Cal_Sta;
    for(i=0;i<3;i++)  *ptr++=Kpg[i];
    ptr=(u16*)&F_Buff;
    for(i=0; i<256; i+=2){                      //128 SHORT
      j= FLASH_ProgramHalfWord(Kpg_Address+i, *ptr++);
      if(j!= FLASH_COMPLETE) break;
    }
  }
  FLASH_Lock();
  return j;
}
/*******************************************************************************
Read_Kpg: FLASHУ׼
*******************************************************************************/
void Read_Kpg(void)
{
  u8 i;
  u16* ptr;
  ptr=(u16*)(Kpg_Address);
  if(*ptr++!=0xaa55) return ;
  if(*ptr++!=0x0400) return ;
  Cal_Sta = *ptr++;
  for(i=0;i< 3;i++) Kpg[i] = *ptr++;  //CH_A,CH_B ƫ
  return ;
}
/*******************************************************************************
Read_Kpg: FLASHУ׼
*******************************************************************************/
void Read_CalFlag(void)
{
  u16* ptr;
  ptr=(u16*)(Kpg_Address);
  if(*ptr++!=0xaa55) return ;
  if(*ptr++!=0x0400) return ;
  Cal_Sta = *ptr++;
  return ;
}
/*******************************************************************************
 Print_Clk: ָʾ
*******************************************************************************/
void PrintClk(u16 x0, u16 y0, u8 Phase)
{
  u16 i, j, b;
  SetColor(GRY, TCOLOR[FN]);  
  x0=S_X[SAVE_BMP]+30;
  DispStr(S_X[SAVE_BMP]-3, LABLE_Y, PRN, "             ");
  for(i=1; i<11; ++i){
    b = CLK_TAB[Phase *11 + i];
    for(j=0; j<11; ++j){
      __Set_Posi((x0+j), (y0+i));
      if((b >> j)& 0x001)
        __Set_Pixel(BLU);
      else
        __Set_Pixel(Background);
    }
  }
}

void Restore_CalPar(void)
{
  u8 i = 0;
  List[SMPL_DPTH].Flg |= UPD;
  TIM_BASE_Val=List[TIM_BASE].Val;
  List[TIM_BASE].Val=0;
  Current=0;
  List[MenuNow[Current]].Flg |= UPD;
  for(i=0;i<44;i++) List[i].Val= List_c[i].Val;
  for(i=0;i<8;i++)  MenuNow[i]= MenuNow_C[i];
  TIM_BASE_Val=List[TIM_BASE].Val;
  List[TIM_BASE].Val=0;
  for(i=Y_RANGES; i<=BATTERY; i++){
  List[i].Flg |= UPD;
  }
  Update_Titel();
  Close_Pop();
}

void Restore(void)
{
  u8 i = 0;
  TIM_BASE_Val=List[TIM_BASE].Val;
  Current=0;
  List[MenuNow[Current]].Flg |= UPD;
  for(i=0;i<44;i++) List[i].Val= List_c[i].Val;
  for(i=0;i<8;i++)  MenuNow[i]= MenuNow_C[i];
  for(i=Y_RANGES; i<=BATTERY; i++){
  }
  Update_Titel();
}
/******************************** END OF FILE *********************************/

