/******************** (C) COPYRIGHT 2012 e-Design Co.,Ltd. *********************
 File Name : HDW_Config.c
 Version   : DS211 Ver 1.6                                      Author : bure
*******************************************************************************/
#include "string.h"
#include "HDW_Config.h"
#include "Process.h"
#include "Menu.h"
#include "DFU_Func.h"
#include "USB_bot.h"
#include "USB_desc.h"
#include "Bios.h"
#include "Ext_Flash.h"
/*******************************************************************************
* Set_System: System clock initializtion
*******************************************************************************/
void Set_System(void)
{
  RCC_DeInit();
  RCC_HSEConfig(RCC_HSE_ON);
  if(RCC_WaitForHSEStartUp() == SUCCESS)
  {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
    FLASH_SetLatency(FLASH_Latency_2);    //Flash 2 wait state
    RCC_HCLKConfig(RCC_SYSCLK_Div1);      //HCLK = SYSCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);       //PCLK2 = HCLK
    RCC_PCLK1Config(RCC_HCLK_Div2);       //PCLK1 = HCLK/2
    RCC_ADCCLKConfig(RCC_PCLK2_Div4);     //ADCCLK = PCLK2/4 = 18MHz
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);  //PLLCLK = 72 MHz
    RCC_PLLCmd(ENABLE);
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET){}
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);
    while(RCC_GetSYSCLKSource()!=0x08){}
  }
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);

  RCC_APB2PeriphClockCmd(
    RCC_APB2Periph_ADC1  | RCC_APB2Periph_ADC2  | RCC_APB2Periph_GPIOA |
    RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD |
    RCC_APB2Periph_GPIOE | RCC_APB2Periph_AFIO  | RCC_APB2Periph_TIM1  |
    RCC_APB2Periph_ADC3  , ENABLE);

  RCC_APB1PeriphClockCmd(
    RCC_APB1Periph_TIM2 | RCC_APB1Periph_TIM3 | RCC_APB1Periph_TIM4 |RCC_APB1Periph_TIM5|
    RCC_APB1Periph_SPI2 | RCC_APB1Periph_DAC , ENABLE);

  RCC_USBCLKConfig(RCC_USBCLKSource_PLLCLK_1Div5);     //USBCLK = 48MHz
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USB, ENABLE);  //Enable USB clock

}
/*******************************************************************************
* NVIC_Configuration:  interrupt seting  initializtion
*******************************************************************************/
void NVIC_Configuration(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x8000);

  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);

  NVIC_InitStructure.NVIC_IRQChannel = USB_LP_CAN_RX0_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  NVIC_InitStructure.NVIC_IRQChannel = USB_HP_CAN_TX_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  // enabling TIM1 interrupt
  NVIC_InitStructure.NVIC_IRQChannel=TIM1_CC_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  // enabling TIM3 interrupt
  NVIC_InitStructure.NVIC_IRQChannel=TIM3_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  // enabling DMA interrupt
  NVIC_InitStructure.NVIC_IRQChannel=DMA1_Channel2_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}

/*******************************************************************************
* GPIO_Config: GPIO port initializtion
*******************************************************************************/
void GPIO_Config(void)
{
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);
  GPIO_InitTypeDef         GPIO_InitStructure; 
  GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE);
  
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  
  // ------ GPIO Port A config ------
  GPIO_InitStructure.GPIO_Pin  = LCD_nWR | LCD_RS | LCD_CS ;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin   = DAC_PA | V_BAT | OUT_AN ; 
  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AIN; 
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin   = OUT_PO ; 
  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_IN_FLOATING; 
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin   = V_USB ; 
  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_IN_FLOATING; 
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin   = USB_DN | USB_DP ; 
  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_IN_FLOATING; 
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin   = SWC | SWD ; 
  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_IPU; 
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin  = INP_AI0 | INP_AI1;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN; 
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  // ------ GPIO Port B config ------
  GPIO_InitStructure.GPIO_Pin  = LCD_nRST;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin   = LCD_BL ; 
  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF_PP; 
  GPIO_Init(GPIOB, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin  = SEL_AX ;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin  = SPI_RST|SPI_CS;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin  = SPI_SCK | SPI_MISO | SPI_MOSI;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 
  GPIO_Init(GPIOB, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin  = Pwr_Off;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  GPIO_SetBits(GPIOB, Pwr_Off);
  
  // ------ GPIO Port C config ------
  GPIO_InitStructure.GPIO_Pin  = LCD_nRD | SEL_AZ ;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 
  GPIO_Init(GPIOC, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin  =  KEY_MENU | KEY_RIGHT;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU; 
  GPIO_Init(GPIOC, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin  = SEL_AY ;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		
  
  GPIO_Init(GPIOC, &GPIO_InitStructure);
  
  // ------ GPIO Port D config ------
  GPIO_InitStructure.GPIO_Pin  = KEY_DOWN | KEY_LEFT | KEY_PLAY  | KEY_UP;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU; 
  
  GPIO_Init(GPIOD, &GPIO_InitStructure);
  
  // ------ GPIO Port E config ------
  GPIO_InitStructure.GPIO_Pin  = LCD_DATA;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		
  GPIO_Init(GPIOE, &GPIO_InitStructure);
  
  // ------ GPIO Port F config ------
}

/*******************************************************************************
*  : Timer_configuration    ˵ : ϵͳʱʼ
*******************************************************************************/
void Tim_Config(void)
{
//---------------TIM1ڶʱADC-------------------
  TIM1_PSC = 72-1;
  TIM1_ARR = 1000-1;
  TIM1_CCR1= 500;
  TIM1_CR1 = 0x0094;/*0000 0000 1001 0100
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ
                      |||| |||| |||+--------DIR=1¼
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM1_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM1_RCR = 0x0000;/*0000 0000 0000 0001
                      |||| |||| ++++ ++++---ڱضģʽ£PWMڵĿ+1
                      ++++-++++-------------*/
  TIM1_CCER =0x0001;/*0000 0000 0000 0001
                      |||| |||| |||| |||+---CC1E=1OC1źӦ
                      |||| |||| |||| ||+----CC1P=0OC1ߵƽЧ
                      |||| |||| |||| |+-----CC1NE=0OC1Nֹ
                      |||| |||| |||| +------CC1NP=0OC1NߵƽЧ
                      ++++-++++-++++--------CC2CC3CC4Ϊλֵ*/
  TIM1_CCMR1=0x0078;/*0000 0000 0111 1100
                      |||| |||| |||| ||++---CC1S=00CC1ͨΪ
                      |||| |||| |||| |+-----OC1FE=1Ƚ1 ʹܣ
                      |||| |||| |||| +------OC1PE=1Ƚ1Ԥװʹ
                      |||| |||| |+++--------0C1M=111PWMģʽ2
                      |||| |||| +-----------OC1CE=0OC1REF ETRFӰ
                      ++++-++++-------------CC2ͨΪλֵ*/
  TIM1_BDTR =0x8000;/*1000 0000 0000 0000
                      |+++-++++-++++-++++---λֲ
                      +---------------------MOE=0ʹ*/
  TIM1_DIER =0x4200;/*0100 0011 0000 0000  DMAжʹܼĴ
                       |     ||        +----CC1IE=0/Ƚ1ж
                       |     |+-------------UDE=1µDMA
                       |     +--------------CC1DE=1/Ƚ1DMA
                       +--------------------TDE=1DMA*/
  TIM1_CR1 |=0x0001;//CEN=1ʹTIMER1

//-----------------TIM2_CH1PWMLCD-------------------
#ifdef PA_TIM2  

  TIM2_PSC = 1799;
  TIM2_ARR = 100-1;              //72MHz/3840=17.58KHz
  TIM2_CCR1= 50;
  TIM2_CR1 = 0x0084;/*0000 0000 1000 0100
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM2_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  
  TIM2_CCMR1=0x007C;/*0111 1100 0000 0000
                      |||| |||| ++++-++++---CC3ͨΪλֵ
                      |||| ||++-------------CC4S=00CC4ͨΪ
                      |||| |+---------------OC4FE=1Ƚ4 ʹܣ
                      |||| +----------------OC4PE=1Ƚ4Ԥװʹ
                      |+++------------------0C4M=111PWMģʽ2
                      +---------------------OC4CE=0OC4REF ETRFӰ*/
  TIM2_CCER =0x0003;/*0011 0000 0000 0000
                      |||| ++++-++++-++++---CC1CC2CC3Ϊλֵ
                      |||+------------------CC4E=1OC4źӦ
                      ||+-------------------CC4P=1OC4͵ƽЧ
                      |+--------------------CC4NE=0OC4Nֹ
                      +---------------------CC4NP=0OC4NߵƽЧ*/
  TIM2_CR1 |=0x0001;//CEN=1ʹTIMER2
#endif  
//-----------------TIM5_CH3PWMYͨƫƵѹֵ-------------------
  TIM5_PSC = 7;
  TIM5_ARR = FARR[List[FREQ_OUT].Val];              //72MHz/3840=17.58KHz
  TIM5_CCR3= (FARR[List[FREQ_OUT].Val]+1)/2;
  TIM5_CR1 = 0x0084;/*0000 0000 1000 0100
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM5_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM5_CCER =0x0100;/*0000 0011 0000 0000
                      |||| ++++-++++-++++---CC1CC2CC3Ϊλֵ
                      |||+------------------CC3E=1OC3źӦ
                      ||+-------------------CC3P=1OC3͵ƽЧ
                      |+--------------------CC3NE=0OC3Nֹ
                      +---------------------CC3NP=0OC3NߵƽЧ*/
  TIM5_CCMR2=0x0078;/*0111 1100 0000 0000
                      |||| |||| ++++-++++---CC4ͨΪλֵ
                      |||| ||++-------------CC3S=00CC3ͨΪ
                      |||| |+---------------OC3FE=1Ƚ3ʹܣ
                      |||| +----------------OC3PE=1Ƚ3Ԥװʹ
                      |+++------------------0C3M=111PWMģʽ2
                      +---------------------OC3CE=0OC3REF ETRFӰ*/
  TIM5_CR1 |=0x0001;//CEN=1ʹTIMER2
  
//-----------------TIM3ϵͳʱ-------------------
  TIM3_PSC  =9;  //9
  TIM3_ARR  =7199;  //1mS =PSC+1ARR+1/72MHz/2uS
  TIM3_CCR1 =3600; //ȣռձȣ50%
  TIM3_CR1 = 0x0084;/*0000 0000 1000 0100
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM3_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM3_DIER =0x0002;/*0000 0000 0000 0010  DMAжʹܼĴ
                             |         +----CC1IE=1/Ƚ1ж
                             +--------------CC1DE=1/Ƚ1DMA*/
  TIM3_CR1 |=0x0001;//CEN=1ʹTIMER3

//------------------TIM4_CH2LCD----------------------
#ifdef PA_TIM2   
#endif  
  TIM4_PSC  = 1800-1;   //400Hz
  TIM4_ARR  =  100-1;
  TIM4_CCR4 =  50;
  TIM4_CR1 = 0x0084;/*0000 0000 1000 0100
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM3_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM4_CCER =0x3000;/*0000 0000 0000 0001
                      |||| |||| |||| |||+---CC1E=1OC1źӦ
                      |||| |||| |||| ||+----CC1P=0OC1ߵƽЧ
                      |||| |||| |||| |+-----CC1NE=0OC1Nֹ
                      |||| |||| |||| +------CC1NP=0OC1NߵƽЧ
                      ++++-++++-++++--------CC2CC3CC4Ϊλֵ*/
  TIM4_CCMR2=0x7C00;/*0000 0000 0111 1100
                      |||| |||| |||| ||++---CC1S=00CC1ͨΪ
                      |||| |||| |||| |+-----OC1FE=1Ƚ1 ʹܣ
                      |||| |||| |||| +------OC1PE=1Ƚ1Ԥװʹ
                      |||| |||| |+++--------0C1M=111PWMģʽ2
                      |||| |||| +-----------OC1CE=0OC1REF ETRFӰ
                      ++++-++++-------------CC2ͨΪλֵ*/
  TIM4_CR1 |=0x0001;//CEN=1ʹTIMER4
 
 
  //------------TIM_DA=timer7-----------------------------------------//
  TIM_DA->PSC   = 2-1;
  TIM_DA->ARR   = 1000-1; //Period = 72MHz/2000/36 = 1000Hz
  TIM_DA->DIER  = 0x0100; // Update DMA request enable
  TIM_DA->CR1   = 0x0085;
  
}
/*******************************************************************************
* SPI_Config: SPI  port initializtion
*******************************************************************************/
void SPI_Config(void)
{
  SPI_InitTypeDef   SPI_InitStructure;

  
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPIx, &SPI_InitStructure);  // SPI2 Config
  SPI_Cmd(SPIx, ENABLE);               // SPI2 enable
  
  
  ExtFlash_CS_HIGH();
  ExtFlash_RST_LOW ();
  __Ctrl(DELAYmS, 100);
  ExtFlash_RST_HIGH();
    
}
/*******************************************************************************
* DMA_configuration: DMA channel initializtion
*******************************************************************************/
void DMA_Configuration(void)
{
  DMA_ISR = 0x00000000;/*DMAж״̬ĴͨIFCRӦλ
              |||||||+---GIF1 =0ͨ1ûTEHTTC¼ȫжϱ־
              |||||||+---TCIF1=0ͨ1ûжϱ־
              |||||||+---HTIF1=0ͨ1û봫жϱ־
              |||||||+---TEIF1=0ͨ1ûжϱ־
              ||||||+----ͨ2жϱ־
              ||||++-----ͨ3жϱ־
              ||||++-----ͨ4жϱ־
              |||+-------ͨ5жϱ־
              ||+--------ͨ6жϱ־
              ||+--------ͨ7жϱ־
              +----------*/
  DMA_IFCR= 0x00000000;/*DMAжϱ־Ĵû
              |||||||+---CGIF1 =1ͨ1TEHTTC¼ȫжϱ־
              |||||||+---CTCIF1=1ͨ1Ĵжϱ־
              |||||||+---CHTIF1=1ͨ1İ봫жϱ־
              |||||||+---CTEIF1=1ͨ1Ĵжϱ־
              ||||||+----ͨ2жϱ־
              ||||++-----ͨ3жϱ־
              ||||++-----ͨ4жϱ־
              |||+-------ͨ5жϱ־
              ||+--------ͨ6жϱ־
              ||+--------ͨ7жϱ־
              +----------*/
  DMA1_CCR1=  0x00003580;/*0011 0101 1000 0000
               ||||       |||| |||| |||| |||+--EN = 0ͨرգ1ͨ
               ||||       |||| |||| |||| ||+---TCIE=0ж
               ||||       |||| |||| |||| |+----HTIE=0ֹ봫ж
               ||||       |||| |||| |||| +-----TEIE=0ֹж
               ||||       |||| |||| |||+-------DIR =0ݴ䷽򣨴
               ||||       |||| |||| ||+--------CIRC=0ִѭ
               ||||       |||| |||| |+---------PINC=0ִַģʽ
               ||||       |||| |||| +----------MINC=1ִд洢ַģʽ
               ||||       |||| ||++------------PSIZE=0116λݿ
               ||||       |||| ++--------------MSIZE=0116λ洢ݿ
               ||||       ||++-----------------PL=11ͨȼ
               ||||       |+-------------------MEM2MEM=0Ǵ洢洢ģʽ
               ++++-------+--------------------*/

  DMA1_CNDTR1 = 0x00001000;          // DMAͨ1Ĵ(1024*2 Bytes)
  DMA1_CPAR1  = ADC1_DR_ADDR;        // DMAͨ1ݼĴַ
  DMA1_CMAR1  = (u32)&Sampl[2];      // DMAͨ1ԴĿĴ洢ַ
  DMA1_CCR1  |= 0x00000001;          // EN = 1DMAͨ1
}
/*******************************************************************************
* ADC_configuration: ADC initializtion
*******************************************************************************/
void ADC_Configuration(void)
{
  ADC3_CR1 =0x00000100; //VBat 0x00000400
  ADC2_CR1 =0x00000000;
  ADC1_CR1 =0x00000000;/*
              ||||||++---AWDCH[4:0]ģ⿴Źͨѡλ
              ||||||+----=000EOCAWDJEOCж
              |||||+-----Nib8_SCAN=0ʹɨģʽ
              ||||++-----ָλֵ
              |||+-------DUALMOD=0ģʽ  0111:ٽģʽ(ADC2ADC3ЩλΪλ)
              ||+--------ͨעͨģ⿴Ź
              ++---------*/
  ADC3_CR2 =0x005E0002; //
  ADC2_CR2 =0x00100000; //(ֻADC1ADC3DMA)
  ADC1_CR2 =0x00100100;/*
              |||||||+---ADON=0رADCת/У׼=1ADCת
              |||||||+---CONT=01תģʽ
              |||||||+---CAL=0=1A/DУʼ׼У׼λӲ
              |||||||+---RSTCAL=0=1ʼУ׼ĴУ׼λӲ
              ||||||+----
              |||||+-----ALIGN=0 & DMA=1ҶʹDMAģʽ
              ||||+------
              |||+-------=0000ͨʹöʱ1CC1¼ת=1110SWSTART
              ||+--------=1ʹⲿźת
              ++---------*/
  ADC3_SQR1=0x00000000;
  ADC2_SQR1=0x00000000;
  ADC1_SQR1=0x00000000;/*ADCмĴ 1
              ||++++++---SQ13-16=00000תе13-16תͨ(5Bits*4)
              ++---------*/
  ADC3_SQR3 =0x00000001;  //ACD3_IN1  ͨ1
  ADC2_SQR3 =0x00000007;  //ACD2_IN17 PA7 //ACD2_IN15 ͨ15
  ADC1_SQR3 =0x00000006;/*ADCмĴ ACD1_IN6 ͨ6
               ||||||++---SQ1=00000תеĵ1תͨı(0)
               +++++++----SQ2-6=00000תе2-6תͨ(5Bits*5)
               +----------*/
  ADC3_SMPR2=0x00000001;
  //ADC2_SMPR1=0x00008000; //15ͨ001 7.5T
  ADC2_SMPR2=0x00000000;   //ʹͨ15Ĳʱ 1.5T
  
  //ADC1_SMPR2=0x00000000; //0x00100000
  ADC1_SMPR2=0x00000000;/*ADCʱĴ 1
               |||||||+---SMP01=001(3Bits)ʹͨ00Ĳʱ 1.5T
               ||||+------SMP04=001(3Bits)ʹͨ04Ĳʱ 7.5T
               |+++++++---SMP11-17=000(3Bits*7)ͨ11-17Ĳʱ 1.5T
               ++---------*/
  ADC1_CR2 |=0x00000001;
  ADC2_CR2 |=0x00000001;       //ADON=1ADC1ADC2
  ADC3_CR2 |=0x00000001; 
  
  ADC1_CR2 |=0x00000008;
  while(ADC1_CR2 & 0x00000008);//ʼADC1У׼Ĵ
  ADC2_CR2 |=0x00000008;
  while(ADC2_CR2 & 0x00000008);//ʼADC2У׼Ĵ
  ADC3_CR2 |=0x00000008;
  while(ADC3_CR2 & 0x00000008);//ʼADC2У׼Ĵ
  
  ADC1_CR2 |=0x00000004;
  while(ADC1_CR2 & 0x00000004);//ADC1У׼
  ADC2_CR2 |=0x00000004;
  while(ADC2_CR2 & 0x00000004);//ADC2У׼
  ADC3_CR2 |=0x00000004;
  while(ADC3_CR2 & 0x00000004);//ADC2У׼
  
  ADC3_CR2 |=0x005E0002; //
  
  /*
  u32 timeout = 10*0x1000;
  ADC_InitTypeDef   ADC_InitStructure;
  
  ADC_DeInit(ADC3);
  ADC_InitStructure.ADC_Mode               = ADC_Mode_Independent;
  ADC_InitStructure.ADC_ScanConvMode       = ENABLE;
  ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;
  ADC_InitStructure.ADC_ExternalTrigConv   = ADC_ExternalTrigConv_None;
  ADC_InitStructure.ADC_DataAlign          = ADC_DataAlign_Right;
  ADC_InitStructure.ADC_NbrOfChannel       = 1;
  ADC_Init(ADC3, &ADC_InitStructure);
  
  ADC_RegularChannelConfig(ADC3, ADC_Channel_1, 1, ADC_SampleTime_7Cycles5); //28 or 55
  
  ADC_Cmd(ADC3, ENABLE);                        
  
  ADC_ResetCalibration(ADC3);                  
  while(ADC_GetResetCalibrationStatus(ADC3)) ; 
  
  ADC_SoftwareStartConvCmd(ADC3, ENABLE);
  */
}
/*******************************************************************************
*DAC_Config
*******************************************************************************/
void DAC_Config(void)
{
  /*
  DAC_InitTypeDef    DAC_InitStructure;
  
  DAC_InitStructure.DAC_Trigger                      = DAC_Trigger_None;
  DAC_InitStructure.DAC_WaveGeneration               = DAC_WaveGeneration_None;
  DAC_InitStructure.DAC_LFSRUnmask_TriangleAmplitude = DAC_LFSRUnmask_Bit0;
  DAC_InitStructure.DAC_OutputBuffer                 = DAC_OutputBuffer_Enable;
  DAC_Init(DAC_Channel_1, &DAC_InitStructure);
  
  DAC_Cmd(DAC_Channel_1, ENABLE);
  */
  DAC_CR   =0x00010000;/*DAC control register 
              |||||||+--Bit0 =1 DAC channel1 enabled
              |||||||+--Bit1 =0 DAC channel1 output buffer enabled
              |||||||+--Bit2 =0 DAC channel1 trigger disabled
              ||||||++--Bits5:3 =000 DAC channel1 trigger selection
              ||||||+---Bits7:6 =00 DAC channel1 wave generation disabled
              |||||+----Bits11:8 =0000 DAC channel1 mask/amplitude selector
              ||||+-----Bit12 =0 DAC channel1 DMA mode disabled
              |||+------Bit16 =0 DAC channel2 disabled
              |||+------Bit17 =0 DAC channel2 output buffer enabled
              |||+------Bit18 =0 DAC channel2 trigger disabled
              ||++------Bits21:19 =00 DAC channel2 trigger selection
              ||+-------Bits23:22 =00 DAC channel2 wave generation disabled
              |+--------Bits27:24 =0000 DAC channel2 mask/amplitude selector
              +---------Bit28 =0 DAC channel2 DMA mode disabled*/  
  DAC_DHR12R2 = 682;//(49*4095)/300;//10mv
  //DAC_DHR12R2  =  1024;
  
  DAC_InitTypeDef    DAC_InitStructure;

  DAC_InitStructure.DAC_Trigger                      = DAC_Trigger_None;
  DAC_InitStructure.DAC_WaveGeneration               = DAC_WaveGeneration_None;
  DAC_InitStructure.DAC_LFSRUnmask_TriangleAmplitude = DAC_LFSRUnmask_Bit0;
  DAC_InitStructure.DAC_OutputBuffer                 = DAC_OutputBuffer_Enable;
  DAC_Init(DAC_Channel_1, &DAC_InitStructure);
  
  DAC_Cmd(DAC_Channel_1, ENABLE);
  
}
/******************************** END OF FILE *********************************/
