/******************** (C) COPYRIGHT 2011 e-Design Co.,Ltd. *********************
 File Name : Menu.c
 Version   : DS211 Ver 1.6                                  Author : bure
*******************************************************************************/
#include "Process.h"
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include "Menu.h"
#include "Draw.h"
#include "Func.h"
#include "BIOS.h"
#include "math.h"
#include "HDW_Config.h"

typedef uint64_t     u64;

u8   Windows_Pop = 0;
u8   Freq_Flag = 1, StdBy_Flag = 0, PwrOff_Flag = 0;
u16  Freq_Cnt  = 0;
u16  StdBy_Time = 0, PwrOff_Time = 0; 
uc8  XSTR[][6] = {"uS", "mS", "S "};
uc8  YSTR[][6] = {"uV", "mV", "V "};
uc8  FSTR[][6] = {"Hz", "Hz", "KHz", "MHz"};
uc8  PCNT[]    =  "%";
uc8  NSTR[][6] = {"  ", "  ", "  "};

//----------+------+------+------+------+------+------+------+------+------+------+
// Yx1  |   0  |   1  |   2  |   3  |   4  |   5  |   6  |   7  |   8  |   9  |
// Yx10 |  10  |  11  |  12  |  13  |  14  |  15  |  16  |  17  |  18  |  19  |
//----------+------+------+------+------+------+------+------+------+------+------+
uc8  R[][6]={"10mV","20mV","50mV","0.1V","0.2V","0.5V","1.0V","2.0V","5.0V"," 10V",
             "0.1V","0.2V","0.5V","1.0V","2.0V","5.0V"," 10V"," 20V"," 50V","100V" };
//----------+------+------+------+------+------+------+------+------+------+------+
// ɨʱ |   0  |   1  |   2  |   3  |   4  |   5  |   6  |   7  |   8  |   9  |
// λ:  |  10  |  11  |  12  |  13  |  14  |  15  |  16  |  17  |  18  |  19  |
//----------+------+------+------+------+------+------+------+------+------+------+
uc8  B[][6]={"1uS " ,"2uS " ,"5uS " ,"10uS","20uS","50uS",".1mS",".2mS",".5mS","1mS " ,
             "2mS " ,"5mS " ,"10mS","20mS","50mS","0.1S","0.2S","0.5S"," 1S "," 2S ",};
//----------+------+------+------+------+------+------+------+------+------+------+
uc16 PSC[] ={ 12-1 , 12-1 , 12-1 , 12-1 , 12-1 , 16-1 , 16-1 , 16-1 , 16-1 , 16-1 ,
              16-1 , 32-1 ,  64-1, 64-1 , 128-1, 256-1, 256-1, 256-1, 512-1, 512-1};

//----------+------+------+------+------+------+------+------+------+------+------+
uc16 ARR[] ={ 6-1  , 6-1 ,  6-1  , 6-1 , 6-1  ,  9-1 , 18-1 , 36-1 ,  90-1 ,   180-1,
              360-1, 450-1, 450-1, 900-1,1125-1,1125-1,2250-1,5625-1, 5625-1,11250-1};

//----------+------+------+------+------+------+------+------+------+------+------+
uc16 KS[]  ={  51  ,  102 ,  256 ,  512 , 1024 , 1024 , 1024 , 1024 , 1024 , 1024 ,
/*ֵϵ */ 1024 , 1024 , 1024 , 1024 , 1024 , 1024 , 1024 , 1024 , 1024 , 1024 };
//----------+------+------+------+------+------+------+------+------+------+------+


//--------------------------ģⲨηƵ------------------------------------
uc16 Dac_Psc[12] = {4,    2,    2,   2,   2,    2,   2,   2,    2,   2,   2};
uc16 Dac_Tim[12] = {10000,10000,4000,2000,1000, 400, 200, 100,  40,  20,  10};

//Ƶʼ㹫ʽQ=72MHZ/FPSC/FARR)
//----------+-------+-------+-------+-------+-------+-------+-------+-------+
// Ƶ |   0   |   1   |   2   |   3   |   4   |   5   |   6   |   7   |
// λ:|   8   |   9   |  10   |  11   |  12   |  13   |  14   |  15   |
//----------+-------+-------+-------+-------+-------+-------+-------+-------+
uc8  Q[][6]={ "10Hz", "20Hz", "50Hz","100Hz","200Hz","500Hz","1KHz ","2KHz",
              "5KHz","10KHz","20KHz","50KHz",".1MHz",".2MHz",".5MHz","1MHz"};
//----------+-------+-------+-------+-------+-------+-------+-------+-------+
uc16 FPSC[]={  128-1,  128-1,   64-1,   64-1,   16-1,   16-1,    4-1,    4-1,
                 1-1,    1-1,    1-1,    1-1,    1-1,    1-1,    1-1,    1-1};
//----------+-------+-------+-------+-------+-------+-------+-------+-------+
uc16 FARR[]={56250-1,28125-1,22500-1,11250-1,22500-1, 9000-1, 18000-1,9000-1,
             14400-1, 7200-1, 3600-1, 1440-1,  720-1,  360-1,  144-1,   72-1};
//----------+-------+-------+-------+-------+-------+-------+-------+-------+

/**************************V5.02**********************************/
//-------------+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
//  ߶   | 0| 1| 2| 3| 4| 5| 6| 7| 8| 9|10|11|12|13|14|15|16|17|18|19|
//-------------+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
//uc8  B_SCALE[]={ 4, 8, 2, 4, 8, 2, 4, 8, 2, 4, 4, 8, 2, 4, 8, 2, 4, 8, 2, 4};
  uc8  X_SCALE[]={ 4, 8, 2, 4, 8, 2, 4, 8, 2, 4, 4, 8, 2, 4, 8, 2, 4, 8, 2, 4};
  uc8  B_SCALE[]={ 4, 8, 2, 4, 8, 2, 4, 8, 2, 4, 8, 2, 4, 8, 2, 4, 8, 2, 4,8};
//-------------+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
//uc8  T_SCALE[]={ 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6};
  uc8  T_SCALE[]={ 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6, 6, 7, 7, 7};
//-------------+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
  uc8  V_SCALE[]={ 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6};
//-------------+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
/***************************************************************/

uc32 VScale[]    = { 10,20, 50, 100, 200, 500, 1000, 2000, 5000,  10000};
u64  VScale_10X[]= { 100, 200, 500, 1000, 2000, 5000,  10000,20000,50000, 100000,};
uc32 TScale[]    = { 1,     2,    5,   10,    20,     50,                        
                     100, 200,  500,  1000, 2000,    5000,  10000, 20000, 50000, 
                     100000, 200000, 500000, 1000000, 2000000};   

uc8  Vol_Str[][8]       ={" 10mV  "," 20mV  "," 50mV  "," 0.1V  "," 0.2V  ",
                          " 0.5V  "," 1.0V  "," 2.0V  "," 5.0V  "," 10V   "};
uc8  Vol_10X[][8]       ={" 0.1V  "," 0.2V  "," 0.5V  "," 1.0V  "," 2.0V  ",
                          " 5.0V  "," 10V   "," 20V  "," 50V  "," 100V  ",};
uc8  TimeBase_Str[][8]  ={"1.0uS","2.0uS","5.0uS","10uS ","20uS ","50uS ",
                          "0.1mS","0.2mS","0.5mS","1.0mS", 
                          "2.0mS","5.0mS","10mS ","20mS ","50mS ","0.1S ",
                          "0.2S ","0.5S ","1.0S ","2.0S "};
uc8  VScale_Str[][6]    ={"10",   "20",   "50",   "100",  "200", 
                          "500",  "1000", "2000", "5000", "10000"};
uc8  VScale_Str_10X[][6]={"100",   "200",   "500",   "1000",  "2000", 
                          "5000",  "10000", "20000", "50000", "100000"};
uc8  TScale_Str[][8]   = { "1",    "2",     "5",     "10",    "20",   "50",   "100",                        
                           "200",  "500",   "1000",  "2000",  "5000", "10000","20000",
                           "50000","100000","200000","500000","1000000", "2000000"}; 

//==============+======+======+======+======+======+======+======+======+======+
//  ״̬    |  | ȫ |  |  | ȫ |  |  |             |
//--------------+------+------+------+------+------+------+------+------+------+
uc8  BT_S[][5] ={ ";<=", ";<=", ";&@", ";*@", ">`@", "\"#$", "\"#$"};// Ŵ |
uc16 V_BT[]    ={  3250,  3300,  3400,  3700,  3900,  4200,  4200};  // ѹֵ |
uc16 BT_C[]    ={  RED,   YEL,   GRN,   GRN,   GRN,   CYN,   CYN };  // ɫ   |
//==============+======+======+======+======+======+======+======+======+======+

uc8  Trig_SYMB[][6]     ={ "^",   "_" };

uc8  P[][6] = {"%"};
uc8  S[][6] = {"/Sec",};
uc8  A[][6] = {"_"   , "@"};
uc8  E[][6] = {"H"   , "L"};
uc8  N[][6] = {"1"   , "10"};
uc8  L[][6] = {"Save", "LOad"};
uc8  T[][6] = {"uS"  , "uS"   , "mS"   , "S " };
uc8  V[][6] = {"uV"  , "mV"   , "V "   , "kV"};
uc8  F[][6] = {"Hz"  , "Hz"   , "K "   , "M "};
uc8  D[][6] = {"1K"  , "2K"   , "4K"   , "8K"};
uc8  M[][6] = {"STOP", "SCAN" , "AUTO" , "NORM" , "SNGL"};
uc8  I[][6] = {"Data ", "-Data", "Inp+D", "D-Inp", "Inp-D", "-Inp ", "Hide "};
uc8  C[][6] = {".BMP", ".DAT" , ".BUF" , ".CSV" , ".SVG" , ".DAT" , ".BUF"};
uc8  Z[][6] = {"Freq", "Duty" , "Vrms" , "Vavg" , "Vp_p" , "Vmax" , "Vmin"};
uc8  CP[][6] ={" DC"   , " AC"};
uc8  OT[][6] ={"SQU  ", "SIN  " ,  "TRI  ", "SAW  "};
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
// ⶨ   |ֱ |ˮƽ | | |չ | |ϵͳ | |                |
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
uc8 TSTR[][4]={"Yn" ,"Xn" ,"Tr" ,"Me" ,"Ex" ,"Fn" ,"Sn" ,"St" };//ַ   |
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
uc16 TCOLOR[]={ CYN , YEL , GRN , WHT , PUR , BLU , ORN , CYN };//ɫֵ   |
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
uc8 TITEL_Y[]={ 200 , 175 , 150 , 125 , 100 ,  75 ,  50 ,  25 };// Y   |
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
uc8 BLOCK_X[]={ 220 , 220 , 220 , 230 , 220 , 220 , 220 , 220 };//˵X  |
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
uc8 BLOCK_Y[]={  70 ,  70 ,  67 ,  30 ,  62 ,  19 ,  11 ,   3 };//˵Y  |
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
uc8 BLOCK_W[]={  70 ,  70 ,  70 ,  44 ,  70 ,  70 ,  70 ,  70 };//˵   |
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
uc8 M_ITEMS[]={   7 ,   6 ,   6 ,   7 ,   3 ,   7 ,   3 ,   5 };//˵Ŀ |
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
uc8 MU_BEGN[]={   0 ,   7 ,  13 ,  19 ,  26 ,  29 ,  36 ,  39 };//ʼ |
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
u8  MenuNow[]={   0 ,   7 ,  13 ,  19+1 ,  26 ,  29 ,  36 ,  39 };//ǰĿ |
uc8 MenuNow_C[]={ 0 ,   7 ,  13 ,  19+1 ,  26 ,  29 ,  36 ,  39 };//ǰĿ |
//------------+-----+-----+-----+-----+-----+-----+-----+-----+----------------+
//----ĿӢַ----------------------------------------------------------------------------------//
uc8 ESTR[][10]={" Y Ranges ",  " Coupling ",  " ProbeAtt ",  " Y Offset ",  " CursorV1 ",  " CursorV2 ",  " Hide_Vn_ ",
                " TimeBase ",  " ViewPosi ",  " SmplDpth ",  " CursorT1 ",  " CursorT2 ",  " Hide_Tn_ ",   
                " SyncMode ",  " TrigMode ",  " Auto Fit ",  " Threshol ",  " Sensitiv ",  " Hide-Tri ",
                " Freq "  ,    " Duty "  ,    " Vrms "  ,    " Vavg "  ,    " Vp-p "  ,    " Vmax "  ,    " Vmin "  ,
                " Ext Refn ",  " Ext Posi ",  " Ext Hide ",                  
                " Save Bmp ",  " Save Dat ",  " Save Buf ",  " Save Csv ",  " Save Svg ",  " Load Dat ",  " Load Buf ",
                " Out Tpye ",  " Out Freq ",  " Out Duty ",      
                " B-Light  ",  " Auto Cal ",  " Restore  ",  " Standby  ",  " PowerOff ",                     
                " Battery " };  
//----ĿϢx--------------------------------------------------------------------------------//							                             

uc16 S_X[]={	47  , 47+24 ,32  ,120 , 7  , 7  ,  0 ,   
                112 ,100 ,248 ,  7 , 7  , 0  , 		        
                289   ,221 ,207 ,  0 ,231 , 0  ,	              
                162 ,162 ,162 ,162 ,162 ,162 ,162 ,	          
                168 , 0  ,168 ,                                   
                248 ,248 ,248 ,248 ,248 ,248 ,248 ,              
                7   , 7  ,  7 ,                                    
                7   , 7  ,  7 ,   7,   7,                                    
                8}; 
//----Ŀֵ--------------------------------------------------------------------------------// 
sc16 MAX[]=	{ 9   ,1  ,1    ,198, 198, 198, 1 , 
                  19  ,8000 ,3  , 298, 298, 1 , 
                  4   ,1  ,1    ,98 , 98 , 1,
                  100 ,100,100  ,100, 100, 100,100, 
                  5   ,199, 1, 
                  235 ,235,235  ,235,235,235, 235,
                  3,  15  ,9  ,
                  10 ,99,99, 60,60,
                  4};
//----Ŀֵ--------------------------------------------------------------------------------// 
sc16 MIN[]=	{ 1,0,0,2,2,2,0,   								                
                  0, 1, 0, 2,2,0,
                  1,0,0,-98,1,0, 
                  0,0,0,0,0,0,0,
                  0,1,0,
                  0,0,0,0,0,0,0,
                  0,0,1,
                  1,0,0, 0, 0,
                  0};
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
// Ŀ  |    ESTR     |    CSTR        | S_X    |  PTR  | Val | MAX   | MIN   | Flg |
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
item List[]={{/* "Y Ranges",*//*"ѡ"*/ /* 56 ,*/(u8*)R ,   7 , /*  9 ,   0 ,*/ UPD },
             {/* "Coupling",*//*"Ϸʽ"*/ /* 90 ,*/(u8*)CP ,  1 , /*  1 ,   0 ,*/ UPD },
             {/* "ProbeAtt",*//*"̽ͷģʽ"*/ /* 44 ,*/(u8*)N ,   0 , /*  1 ,   0 ,*/ UPD },
             {/* "Y Offset",*//*"ֱƫ"*/ /*120 ,*/     0 , 100 , /*198 ,   2 ,*/ UPD },
             {/* "CursorV1",*//*"λα"*/ /*  0 ,*/(u8*)V , 150 , /*198 ,   2 ,*/ UPD },
             {/* "CursorV2",*//*"λα"*/ /*  0 ,*/(u8*)V ,  25 , /*198 ,   2 ,*/ UPD },
             {/* "CursorTp",*//*"αʽ"*/ /*  0 ,*/     0 ,   0 , /*  1 ,   0 ,*/ UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             {/* "TimeBase",*//*"ʱѡ"*/ /*132 ,*/(u8*)B ,   7 ,/*  19 ,   0 ,*/ UPD },//
             {/* "ViewPosi",*//*"ˮƽλ"*/ /*100 ,*/     0 ,   1 ,/*8192 ,   1 ,*/ UPD },
             {/* "SmplDpth",*//*""*/ /*232 ,*/(u8*)D ,   2 ,/*   3 ,   0 ,*/   0 },
             {/* "CursorT1",*//*"α"*/ /*  0 ,*/(u8*)T ,  50 ,/* 298 ,   2 ,*/ UPD },
             {/* "CursorT2",*//*"Ҷα"*/ /*  0 ,*/(u8*)T , 250 ,/* 298 ,   2 ,*/ UPD },
             {/* "CursorTp",*//*"αʽ"*/ /*  0 ,*/     0 ,   0 ,/*   1 ,   0 ,*/ UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             { /*"SyncMode"*//*"ͬģʽ"*//*   0 ,*/(u8*)M ,   2 , /*  4 ,   1 ,*/ UPD },
             { /*"TrigMode"*//*""*//* 228 ,*/(u8*)E ,   0 , /*  1 ,   0 ,*/ UPD },
             { /*"Auto Fit"*//*"Զֵ"*//* 218 ,*/(u8*)A ,   0 , /*  1 ,   0 ,*/ UPD },
             { /*"Threshol"*//*"ֵ"*//*   0 ,*/     0 ,  15 , /* 98 ,  -98,*/ UPD },      //198
             { /*"Sensitiv"*//*"ز"*//* 238 ,*/     0 ,   5 , /* 98 ,   1 ,*/ UPD },
             { /*"CursorTp"*//*"αʽ"*//*   0 ,*/     0 ,   0 , /*  1 ,   0 ,*/ UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             { /*  " Freq ",*//*  "Ƶֵ"*//* 232 ,*/(u8*)F ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Duty ",*//*  "ռձ"*//* 232 ,*/(u8*)P ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Vrms ",*//*  "Чֵ"*//* 232 ,*/(u8*)V ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Vavg ",*//*  "ƽֵ"*//* 232 ,*/(u8*)V ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Vp-p ",*//*  "ֵ"*//* 232 ,*/(u8*)V ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Vmax ",*//*  "ֵ"*//* 232 ,*/(u8*)V ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Vmin ",*//*  "Сֵ"*//* 232 ,*/(u8*)V ,   0 ,/* 100 ,   0 , */  0 },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             { /*"Ext Refn",*//*"οģʽ"*/ /*172 ,*/(uc8*)I,  0 , /*  5 ,   0 , */UPD },
             { /*"Ext Posi",*//*"ֱƫ"*/ /*  0 ,*/     0 , 80 , /*199 ,   1 , */UPD },
             { /*"Ext Hide",*//*"ο"*/ /*  0 ,*/(uc8*)I,   0 , /*  1 ,   0,  */UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             { /*"Save Bmp",*//*"ͼ"*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Save Dat",*//*"沨"*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Save Buf",*//*""*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Save Csv",*//*""*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Save Svg",*//*""*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Load Dat",*//*"ȡ"*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Load Buf",*//*"ȡ"*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             {/* "Out Tpye",*//*""*/ /*  0 ,*/      0,   0 , /*  1,    0 , */0 },
             {/* "Out Freq",*//*"Ƶ"*/ /*  0 ,*/(u8*)Q ,   6 , /* 15 ,   0 , */UPD },
             {/* "Out Duty",*//*"ռ"*/ /*  0 ,*/(u8*)P ,   5 , /*  9 ,   1 , */UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             {/* "B_LIGHT ",*//*""*/ /* 80 , */    0 ,   5 ,/* 10 ,  1 , */  UPD },
             {/* "AutoCal ",*//*"У"*/ /* 80 , */    0 ,   0 ,/* 99 ,  0 , */  0   },
             {/* "Restore ",*//*""*/ /* 80 , */    0 ,   0 ,/* 99 ,  0 , */  0   },  
             {/* "Standby ",*//*"ʱ"*/ /* 0 , */     0 ,  10 ,/* 99 ,  0 , */  UPD },
             {/* "PowerOff",*//*"ػʱ"*/ /* 0 , */     0 ,  20 ,/* 99 ,  0 , */  UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             {/* "Battery ",*//*"״̬"*//* 295 ,  */   0 ,   1 , /*  4 ,   0 , */UPD }};
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
// Ŀ  |    ESTR     |    CSTR        | S_X    |  PTR  | Val | MAX   | MIN   | Flg |
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
item_c List_c[]={
             {/* "Y Ranges",*//*"ѡ"*/ /* 56 ,*/(u8*)R ,   7 , /*  9 ,   0 ,*/ UPD },
             {/* "Coupling",*//*"Ϸʽ"*/ /* 90 ,*/(u8*)CP ,   1 , /*  1 ,   0 ,*/ UPD },
             {/* "ProbeAtt",*//*"̽ͷģʽ"*/ /* 44 ,*/(u8*)N ,   0 , /*  1 ,   0 ,*/ UPD },
             {/* "Y Offset",*//*"ֱƫ"*/ /*120 ,*/     0 , 100 , /*198 ,   2 ,*/ UPD },
             {/* "CursorV1",*//*"λα"*/ /*  0 ,*/(u8*)V , 150 , /*198 ,   2 ,*/ UPD },
             {/* "CursorV2",*//*"λα"*/ /*  0 ,*/(u8*)V ,  25 , /*198 ,   2 ,*/ UPD },
             {/* "CursorTp",*//*"αʽ"*/ /*  0 ,*/     0 ,   0 , /*  1 ,   0 ,*/ UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             {/* "TimeBase",*//*"ʱѡ"*/ /*132 ,*/(u8*)B ,   7 ,/*  19 ,   0 ,*/ UPD },//
             {/* "ViewPosi",*//*"ˮƽλ"*/ /*100 ,*/     0 ,   1 ,/*8192 ,   1 ,*/ UPD },
             {/* "SmplDpth",*//*""*/ /*232 ,*/(u8*)D ,   2 ,/*   3 ,   0 ,*/   0 },
             {/* "CursorT1",*//*"α"*/ /*  0 ,*/(u8*)T ,  50 ,/* 298 ,   2 ,*/ UPD },
             {/* "CursorT2",*//*"Ҷα"*/ /*  0 ,*/(u8*)T , 250 ,/* 298 ,   2 ,*/ UPD },
             {/* "CursorTp",*//*"αʽ"*/ /*  0 ,*/     0 ,   0 ,/*   1 ,   0 ,*/ UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             { /*"SyncMode"*//*"ͬģʽ"*//*   0 ,*/(u8*)M ,   2 , /*  4 ,   1 ,*/ UPD },
             { /*"TrigMode"*//*""*//* 228 ,*/(u8*)E ,   0 , /*  1 ,   0 ,*/ UPD },
             { /*"Auto Fit"*//*"Զֵ"*//* 218 ,*/(u8*)A ,   0 , /*  1 ,   0 ,*/ UPD },
             { /*"Threshol"*//*"ֵ"*//*   0 ,*/     0 ,  15 , /* 98 ,  -98,*/ UPD },      //198
             { /*"Sensitiv"*//*"ز"*//* 238 ,*/     0 ,   5 , /* 98 ,   1 ,*/ UPD },
             { /*"CursorTp"*//*"αʽ"*//*   0 ,*/     0 ,   0 , /*  1 ,   0 ,*/ UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             { /*  " Freq ",*//*  "Ƶֵ"*//* 232 ,*/(u8*)F ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Duty ",*//*  "ռձ"*//* 232 ,*/(u8*)P ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Vrms ",*//*  "Чֵ"*//* 232 ,*/(u8*)V ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Vavg ",*//*  "ƽֵ"*//* 232 ,*/(u8*)V ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Vp-p ",*//*  "ֵ"*//* 232 ,*/(u8*)V ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Vmax ",*//*  "ֵ"*//* 232 ,*/(u8*)V ,   0 ,/* 100 ,   0 , */  0 },
             { /*  " Vmin ",*//*  "Сֵ"*//* 232 ,*/(u8*)V ,   0 ,/* 100 ,   0 , */  0 },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             { /*"Ext Refn",*//*"οģʽ"*/ /*172 ,*/(uc8*)I,   0 , /*  5 ,   0 , */UPD },
             { /*"Ext Posi",*//*"ֱƫ"*/ /*  0 ,*/     0 , 80 , /*199 ,   1 , */UPD },
             { /*"Ext Hide",*//*"ο"*/ /*  0 ,*/(uc8*)I,   0 , /*  1 ,   0,  */UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             { /*"Save Bmp",*//*"ͼ"*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Save Dat",*//*"沨"*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Save Buf",*//*""*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Save Csv",*//*""*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Save Svg",*//*""*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Load Dat",*//*"ȡ"*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
             { /*"Load Buf",*//*"ȡ"*//* 232 ,*/(u8*)C ,   0 , /*255 ,   0 , */  0 },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             {/* "Out Tpye",*//*""*/ /*  0 ,*/      0,   0 , /*  1,    0 , */0 },
             {/* "Out Freq",*//*"Ƶ"*/ /*  0 ,*/(u8*)Q ,   6 , /* 15 ,   0 , */UPD },
             {/* "Out Duty",*//*"ռ"*/ /*  0 ,*/(u8*)P ,   5 , /*  9 ,   1 , */UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             {/* "B_LIGHT ",*//*""*/ /* 80 , */    0 ,   5 ,/* 10 ,  1 , */  UPD },
             {/* "AutoCal ",*//*"У"*/ /* 80 , */    0 ,   0 ,/* 99 ,  0 , */  0   },
             {/* "Restore ",*//*""*/ /* 80 , */    0 ,   0 ,/* 99 ,  0 , */  0   },  
             {/* "Standby ",*//*"ʱ"*/ /* 0 , */     0 ,  10 ,/* 99 ,  0 , */  UPD },
             {/* "PowerOff",*//*"ػʱ"*/ /* 0 , */     0 ,  20 ,/* 99 ,  0 , */  UPD },
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+
             {/* "Battery ",*//*"״̬"*//* 295 ,  */   0 ,   1 , /*  4 ,   0 , */UPD }};
//-----------+-------------+----------------+--------+-------+-----+-------+-------+-----+

//----------------+------------------------+-----------------+
// Ŀʾַ |           ESTR         |       CSTR      |
//----------------+------------------------+-----------------+
uc8 FnNote[][14]= {"File R/W OK",          /*"ļ"   */
                   "File Ver Er",          /*"ļ汾"   */
                   "Not Found! ",          /*"ļ"   */
                   "File R/W Er",          /*"ļ"   */
                   "Disk Busy! ",          /*"̶д"   */};
//----------------+------------------------+-----------------+

uc16 DEPTH[]={ 1024 , 2048 , 4096 , 8192};//8192

//              0-us                       9--ms                     18--1s
uc32 Ts[] = {25,25,25,25,25,50,100,200,500,1,2,5,10,20,50,100,200,500,1,2};

u8   Current = 0, Status = 0, NumStr[11];
u16  Presampling = X_SIZE/2;
extern u16 Edge;

//------------------------------------------------------------------------------------
/*******************************************************************************
 Update_Item: Update[x]Erase[x]ı־ˢʾĿ
*******************************************************************************/
void Update_Titel(void)
{
  u16 i;

  for(i=0; i<8; i++){
    SetColor(GRY, TCOLOR[i]);
    if(Current == i){
      DispStr8x14(T_X-2, TITEL_Y[i], (Current == i)? INV : PRN, (u8*)TSTR[i]);
      Draw_4Point(T_X-2, TITEL_Y[i], 2, Font8x14_H);
    }else{
      DispStr8x14(T_X-2, TITEL_Y[i], (Current == i)? INV : PRN, (u8*)TSTR[i]);
    }
    
  }
}
/*******************************************************************************
Draw_4Point:Ķǵ
*******************************************************************************/
void Draw_4Point(u16 x, u16 y, u8 Str_Cnt, u8 High)
{
  __Set_Posi(x,y);
  __Set_Pixel(DAR);
  __Set_Posi(x,y+High-1);
  __Set_Pixel(DAR);
  __Set_Posi(x+Str_Cnt*((High>10)? 8:6),y);
  __Set_Pixel(DAR);
  __Set_Posi(x+Str_Cnt*((High>10)? 8:6),y+High-1);
  __Set_Pixel(DAR);
  
}
/*******************************************************************************
 Show_Note: ò˵λáߴ硢ɫʾ
*******************************************************************************/
void Show_List(void)
{
  u16 i, Ny0, Nx0, CurrentMax = MU_BEGN[Current]+ M_ITEMS[Current];
  u8  Flag = 0;;
  u8  str[12];
  ParamTab[BXx1]= BLOCK_X[Current];
  ParamTab[BYx2]= BLOCK_Y[Current]*2;
  ParamTab[WXx1]= BLOCK_W[Current];
  ParamTab[HYx2]=(M_ITEMS[Current]+1)*32;
  PopColor(WHT, DAR);
  Buil_Pop();
  for(i=MU_BEGN[Current]; i<CurrentMax; i++){
    if(i == MenuNow[Current]) {
      Flag = INV;
    }
    else                      {
      PopColor(WHT, DAR);
      Flag = PRN;
    }
    Ny0 = ((CurrentMax - i)*17 - 10);
    Nx0 = N_X ;
    memset(str,0,12);
    memcpy(str,&ESTR[i],10);
    NoteSTR(Nx0, Ny0, Flag, str);
    Note_4Point(PRN, Nx0, Ny0, strlen((char*)str), Font6x8_H);
  }
  List_Pop();
}
/*******************************************************************************
 Update_Blink: ʾ˸
*******************************************************************************/
void Update_Blink(void)
{
  u8* ptr;
  //s32 Tmp ; V5.02
  s_64 Tmp;
  u16 i, Range = List[Y_RANGES].Val + 10*List[PROBEATT].Val;

  i = MenuNow[Current];
  ptr = (u8*)(List[i].PTR +(List[i].Val)*6);
  if(Blink == BLINK){
    Blink = 0;
    //if((i != SMPL_DPTH) && (Current != FN))
    List[MenuNow[ME]].Flg |= UPD;// ָĲβʾ
    switch(i){
    case SAVE_BMP:
    case SAVE_DAT:
    case SAVE_BUF:
    case SAVE_CSV:
    case SAVE_SVG:
    case LOAD_DAT:
    case LOAD_BUF:
      SetColor(GRY, TCOLOR[FN]);
      u8ToDec3(NumStr, List[i].Val);
      Draw_Circle_D(Twink, S_X[i]-3, LABLE_Y, 11, 0, 6*11);
      DispStr(S_X[i],    LABLE_Y, Twink, (u8*)((i > SAVE_SVG)? "Load" : "Save"));//0513
      DispStr(S_X[i]+24, LABLE_Y, Twink, NumStr);
      DispStr(S_X[i]+42, LABLE_Y, Twink, (u8*)(List[i].PTR +(i - SAVE_BMP)*6));
      break;
    case Y_RANGES:
    case COUPLING:
    case PROBEATT: 
      SetColor(GRY, TCOLOR[YN]);
      Draw_Circle_D(Twink, S_X[Y_RANGES]-3, TITLE_Y, 11, 0, 6*7);
      DispStr(S_X[Y_RANGES], TITLE_Y, Twink, (u8*)(List[Y_RANGES].PTR +(Range)*6));
      DispStr(S_X[COUPLING], TITLE_Y, Twink, (u8*)(List[COUPLING].PTR +(List[COUPLING].Val)*6));   
      DispStr10x14(S_X[PROBEATT], TITLE_Y, PRN+SYMB,(List[PROBEATT].Val?(u8*)("A"):(u8*)("B")));
      break;
    case V0_POSI:
      if(Twink) ParamTab[P1F] |=  D_HID;
      else      ParamTab[P1F] &= ~D_HID;
      break;
    case V1_POSI:
    case V2_POSI:
      Tmp = (i == V1_POSI)? V1F : V2F;
      if(Twink) ParamTab[Tmp] |=  D_HID;
      else      ParamTab[Tmp] &= ~D_HID;
      Tmp  =(ParamTab[V1x2]- ParamTab[V2x2])/2;         // V2 - V1 ֵ
      Tmp *= X_SCALE[Range]* Exp(V_SCALE[Range]);
      Value2Str(NumStr, Tmp,(u8*)V, 3, UNSIGN);
      SetColor(GRY, TCOLOR[YN]);
      Draw_Circle_D(Twink, S_X[V1_POSI]-3, LABLE_Y, 11, 0, 6*9);
      DispStr(S_X[V1_POSI]+0*6, LABLE_Y, Twink+SYMB, "]");
      DispStr(S_X[V1_POSI]+1*6, LABLE_Y, Twink,      "V:      ");
      DispStr(S_X[V1_POSI]+3*6, LABLE_Y, Twink,      NumStr);
      break;
    case YN_TYPE:
      if(Twink) ParamTab[V1F] |=  D_HID;
      else      ParamTab[V1F] &= ~D_HID;
      if(Twink) ParamTab[V2F] |=  D_HID;
      else      ParamTab[V2F] &= ~D_HID;
      break;
    case TIM_BASE:
      SetColor(GRY, TCOLOR[XN]);
      Draw_Circle_D(Twink, S_X[i]-3, TITLE_Y, 11, 2, 6*5);
      DispStr(S_X[i], TITLE_Y, Twink, (u8*)TimeBase_Str[List[TIM_BASE].Val]);
      break;

    case VIEWPOSI:
      if(Twink) ParamTab[T0F] |=  D_HID;
      else      ParamTab[T0F] &= ~D_HID;
      break;
    case SMPL_DPTH:
      SetColor(GRY, TCOLOR[XN]);
      Draw_Circle_D(Twink, S_X[SMPL_DPTH]-3, LABLE_Y, 11, 0, 6*11);
      DispStr(S_X[SMPL_DPTH],    LABLE_Y,  Twink, "SmplDpth:  ");
      DispStr(S_X[SMPL_DPTH]+6*9, LABLE_Y,  Twink, (u8*)&D[List[SMPL_DPTH].Val]);
      break;
    case T1_POSI:
    case T2_POSI:
      Tmp = (i == T1_POSI)? T1F : T2F;
      if(Twink) ParamTab[Tmp] |=  D_HID;
      else      ParamTab[Tmp] &= ~D_HID;
      Tmp  = ParamTab[T2x1] - ParamTab[T1x1];          // T2 - T1 ֵ
      Tmp *= B_SCALE[List[TIM_BASE].Val]* Exp(T_SCALE[List[TIM_BASE].Val]);
      if(Tmp>=0)
        Value2Str(NumStr, Tmp, (u8*)T, 3, UNSIGN);
      else
        Value2Str(NumStr, Tmp, (u8*)T, 3, SIGN);
      SetColor(GRY, TCOLOR[XN]);
      Draw_Circle_D(Twink, S_X[T1_POSI]-3, LABLE_Y, 11, 0, 6*9);
      DispStr(S_X[T1_POSI]+0*6, LABLE_Y, Twink+SYMB, "]");
      DispStr(S_X[T1_POSI]+1*6, LABLE_Y, Twink,      "T:      ");
      DispStr(S_X[T1_POSI]+3*6, LABLE_Y, Twink,      NumStr);
      break;
    case XN_TYPE:
      if(Twink) ParamTab[T1F] |=  D_HID;
      else      ParamTab[T1F] &= ~D_HID;
      if(Twink) ParamTab[T2F] |=  D_HID;
      else      ParamTab[T2F] &= ~D_HID;
      break;
    case SYNCMODE:
      if(!(Status &  STOP)){
      SetColor(GRY, TCOLOR[TR]);
      Draw_Circle_D(Twink, S_X[i]-3, TITLE_Y, 11, 1, 6*4);
      DispStr(S_X[i], TITLE_Y, Twink, ptr);
      }
      break;
    case TR_MODE:
    case SENSITIVE:
      SetColor(GRY, TCOLOR[TR]);
      Draw_Circle_D(Twink, S_X[TR_MODE]-3, TITLE_Y, 11, 0, 6*8);
      DispStr10x14(S_X[TR_MODE], TITLE_Y, Twink+SYMB,(List[TR_MODE].Val?(u8*)("D"):(u8*)("C")));
      
      Tmp  = List[SENSITIVE].Val;                        // زֵ
      Tmp *= X_SCALE[Range]* Exp(V_SCALE[Range]);
      Value2Str(NumStr, Tmp, (u8*)V, 2, UNSIGN);
      DispStr(S_X[SENSITIVE]+9, TITLE_Y, Twink,  "     ");  
      DispStr10x14(S_X[SENSITIVE], TITLE_Y, Twink+SYMB,"E");
      DispStr(S_X[SENSITIVE]+9, TITLE_Y, Twink     ,  NumStr);
      
      break;
    case FITTRIGG:
      SetColor(GRY, TCOLOR[TR]);
      DispStr10x14(S_X[FITTRIGG], TITLE_Y, PRN+SYMB,(List[FITTRIGG].Val?(u8*)("F"):(u8*)("B")));
      break;
    case THRESHOLD:
      if(Twink) ParamTab[VTF] |=  D_HID;
      else      ParamTab[VTF] &= ~D_HID;
      break;
    case TR_TYPE:
      if(Twink) ParamTab[VTF] |=  D_HID;
      else      ParamTab[VTF] &= ~D_HID;
      break;
    case EXT_REFN:
      SetColor(GRY, TCOLOR[EX]);
      Draw_Circle_D(Twink, S_X[i]-3, TITLE_Y, 11, 1, 6*5);  
      DispStr(S_X[i], TITLE_Y, Twink, (List[EXT_HIDE].Val)? (u8*)(I[List[EXT_REFN].Val]) : (u8*)I[6]);
      ParamTab[P2F] &= ~D_HID;
      break;
    case EXT_POSI:
      if(Twink) ParamTab[P2F] |=  D_HID;
      else      ParamTab[P2F] &= ~D_HID;
      break;
    case EXT_HIDE:
      SetColor(GRY, TCOLOR[EX]);
      Draw_Circle_D(Twink, S_X[i]-3, TITLE_Y, 11, 1, 6*5);   
      DispStr(S_X[i], TITLE_Y, Twink, (List[EXT_HIDE].Val)? (u8*)(I[List[EXT_REFN].Val]) : (u8*)I[6]);
      ParamTab[P2F] &= ~D_HID;
      break;
    case TPYE_OUT:
      SetColor(GRY, TCOLOR[SN]);
      Draw_Circle_D(Twink, S_X[TPYE_OUT]-3, LABLE_Y, 11, 0, 6*9);
      DispStr(S_X[i],    LABLE_Y, Twink, "FO: "); 
      DispStr(S_X[i]+24, LABLE_Y, Twink, "     ");
      DispStr(S_X[i]+24, LABLE_Y, Twink, (u8*)OT[List[i].Val]);
      
      break;
    case FREQ_OUT:
      SetColor(GRY, TCOLOR[SN]);
      Draw_Circle_D(Twink, S_X[FREQ_OUT]-3, LABLE_Y, 11, 0, 6*9);
      DispStr(S_X[i],    LABLE_Y, Twink, "FO: ");
      DispStr(S_X[i]+24, LABLE_Y, Twink, "     ");    
      DispStr(S_X[i]+24, LABLE_Y, Twink, (u8*)Q[List[i].Val]);   
      break;
    case FREQ_DUT:
      SetColor(GRY, TCOLOR[SN]);
      Value2Str(NumStr, List[i].Val*10, List[i].PTR, 2, UNSIGN);
      Draw_Circle_D(Twink, S_X[FREQ_DUT]-3, LABLE_Y, 11, 0, 6*9);
      DispStr(S_X[i],    LABLE_Y, Twink, "Duty: ");  
      DispStr(S_X[i]+36, LABLE_Y, Twink, "   ");
      DispStr(S_X[i]+36, LABLE_Y, Twink, NumStr);      
      break;
    case B_LIGHT:
      SetColor(GRY, TCOLOR[ST]);
      Value2Str(NumStr, List[B_LIGHT].Val*10, PCNT, 2, UNSIGN);
      Draw_Circle_D(Twink, S_X[i]-3, LABLE_Y, 11, 0, 6*9);
      DispStr(S_X[i], LABLE_Y, Twink+PRN,  " BL:     ");
      DispStr(S_X[i]+30, LABLE_Y, Twink+PRN,  NumStr);
      break;
    case AUTO_CAL:
      if(Twink) ParamTab[P1F] |=  W_HID;
      else      ParamTab[P1F] &= ~W_HID;
      
      SetColor(GRY, TCOLOR[ST]);
      Draw_Circle_D(Twink, S_X[i]-3, LABLE_Y, 11, 0, 6*9);
      DispStr( S_X[i]+0, LABLE_Y, Twink+PRN,  "Press:   ");
      DispStr(S_X[i]+40, LABLE_Y, Twink+SYMB, "{|");//ͣͼ
      break;
    case RESTORE:
      SetColor(GRY, TCOLOR[ST]);
      Draw_Circle_D(Twink, S_X[i]-3, LABLE_Y, 11, 0, 6*9);
      DispStr( S_X[i]+0, LABLE_Y, Twink+PRN,  "Press:   ");
      DispStr( S_X[i]+40, LABLE_Y, Twink+SYMB, "{|");//ͣͼ
      break;
    case STANDBY:
      SetColor(GRY, TCOLOR[ST]);
      Value2Str(NumStr, List[STANDBY].Val, NSTR[0], 2, UNSIGN);
      Draw_Circle_D(Twink, S_X[i]-3, LABLE_Y, 11, 0, 6*9);
      DispStr(S_X[i],    LABLE_Y, Twink+PRN,  " ");
      DispStr(S_X[i]+6, LABLE_Y, Twink+PRN,  NumStr);
      DispStr(S_X[i]+30, LABLE_Y, Twink+PRN,  "min ");
      break;
    case PWR_OFF:
      SetColor(GRY, TCOLOR[ST]);
      Value2Str(NumStr, List[PWR_OFF].Val, NSTR[0], 2, UNSIGN);
      Draw_Circle_D(Twink, S_X[i]-3, LABLE_Y, 11, 0, 6*9);
      DispStr(S_X[i],    LABLE_Y, Twink+PRN,  " ");
      DispStr(S_X[i]+6, LABLE_Y, Twink+PRN,  NumStr);
      DispStr(S_X[i]+30, LABLE_Y, Twink+PRN,  "min ");
      break;
    }
    if(i != V0_POSI)  ParamTab[P1F]   = L_HID ;//0513
  }
}
/*******************************************************************************
 Update_Detail: Ŀʾˢ´
*******************************************************************************/
void Update_Detail(void)
{
  s_64 scale = 0;
  s32  Ak = (KgA[KindA+(StateA?1:0)]*4)/GK[GainA];
  u16 i, k = HighT+LowT;
//s32 Tmp = 0; V5.02
  s_64 Tmp = 0;
  u8 Range = List[Y_RANGES].Val + 10*List[PROBEATT].Val;
  u64 FTmp;
  
  for(i=Y_RANGES; i<=BATTERY; i++){
    if(i==FREQUENC)
    {
      if(Freq_Cnt > 10){
        Freq_Cnt = 0;
        Freq_Flag |= UPD;
      }
      else Freq_Cnt++;
    }
      
    if(List[i].Flg & UPD){
      List[i].Flg &= ~UPD;
      switch (i){
      case B_LIGHT:   // ˢʾУ
        if(StdBy_Flag == 0)TIM4_CCR4 = (List[B_LIGHT].Val) *10;
        break;
      case AUTO_CAL:   // ˢʾУ
        break;
      case Y_RANGES:   // ˢʾ Y ̵λ
      case PROBEATT:   // ˢʾ̽ͷ˥
      case COUPLING:   // ˢʾģʽ״̬
      case V0_POSI:    // ˢʾֱƫλ
      case V1_POSI:    // ˢʾλαλ
      case V2_POSI:    // ˢʾλαλ
      case YN_TYPE:    // ˢʾαʽ
        SetColor(GRY, TCOLOR[YN]);
        if(i == Y_RANGES || i == COUPLING||i == PROBEATT){
      Draw_Circle_D(INV, S_X[Y_RANGES]-3, TITLE_Y, 11, 0, 6*7);
      DispStr(S_X[Y_RANGES], TITLE_Y, INV,      (u8*)(List[Y_RANGES].PTR +(Range)*6));
      DispStr(S_X[COUPLING], TITLE_Y, INV,      (u8*)(List[COUPLING].PTR +(List[COUPLING].Val)*6));
      DispStr10x14(S_X[PROBEATT], TITLE_Y, PRN+SYMB,(List[PROBEATT].Val?(u8*)("A"):(u8*)("B")));
        }
        ParamTab[P1x2] = 2*((List[V0_POSI].Val+1));
        ParamTab[VTx2] = ParamTab[P1x2]+ 2*(List[THRESHOLD].Val+1);
        ParamTab[V1x2] = 2*(List[V1_POSI].Val+1);
        ParamTab[V2x2] = 2*(List[V2_POSI].Val+1);
        ParamTab[V1F]  = (List[YN_TYPE].Val)? L_HID : SHOW;
        ParamTab[V2F]  = (List[YN_TYPE].Val)? L_HID : SHOW;

        Tmp  =(ParamTab[V1x2]- ParamTab[V2x2])/2;         // ˢʾV2-V1ֵ
        Tmp *= X_SCALE[Range]* Exp(V_SCALE[Range]);
        Value2Str(NumStr, Tmp,(u8*)V, 3, UNSIGN);
        Draw_Circle_D(INV, S_X[V1_POSI]-3, LABLE_Y, 11, 0, 6*9);
        DispStr(S_X[V1_POSI]+0*6, LABLE_Y, INV+SYMB, "]");
        DispStr(S_X[V1_POSI]+1*6, LABLE_Y, INV,      "V:      ");
        DispStr(S_X[V1_POSI]+7*6, LABLE_Y, INV,  "  ");
        DispStr(S_X[V1_POSI]+3*6, LABLE_Y, INV,  NumStr);

        SetColor(GRY, TCOLOR[TR]);
        Tmp  = List[SENSITIVE].Val;                       // ˢʾزֵ
        Tmp *= X_SCALE[Range]* Exp(V_SCALE[Range]);
        Value2Str(NumStr, Tmp,(u8*)V, 2, UNSIGN);
        DispStr(S_X[SENSITIVE]+9, TITLE_Y, INV,  "     ");     
        DispStr(S_X[SENSITIVE]+9, TITLE_Y, INV,  NumStr);      
        DispStr10x14(S_X[SENSITIVE], TITLE_Y, INV+SYMB,"E");       
        GainA  = (u8)List[Y_RANGES].Val;   
        
        if((u8)List[Y_RANGES].Val>1)
          KindA  = HV;
        else   
          KindA  = LV;                //Ch1ѡѹѹ
        StateA =  ((u8)List[Y_RANGES].Val>5)?ACT: GND; 
        
        CouplA = (List[COUPLING].Val)? AC : DC;                      // AC);  //AC/DCϷʽ
        __Ctrl(AiRANGE, KindA+CouplA+StateA);             //Ch1״̬ˢ
        AiPosi(List[V0_POSI].Val);                        //Ch1ӲӦλ
        
        break;

       case BATTERY://ʾ״̬
        if(USB_On())
        {
          Tmp = Bat_Vol(); 
          if(Tmp > V_BT[6])     SetColor(GRY, BT_C[6]);
          else                  SetColor(GRY, BT_C[5]);
          Draw_Circle_D(INV, S_X[BATTERY]-3, TITLE_Y, 11, 1, 6*3);
          DispStr(S_X[BATTERY], TITLE_Y, INV+SYMB, (u8*)&BT_S[5]);     // ʾ USB ־
        }
        else {
          Tmp = Bat_Vol();                                // صѹ(mV)
          
          if(Tmp > V_BT[4])     {
            SetColor(GRY, BT_C[4]);
            Draw_Circle_D(INV, S_X[BATTERY]-3, TITLE_Y, 11, 1, 6*3);
            DispStr(S_X[BATTERY], TITLE_Y, INV+SYMB, (u8*)&BT_S[4]);
          }
          else if(Tmp > V_BT[3]){
            SetColor(GRY, BT_C[3]);
            Draw_Circle_D(INV, S_X[BATTERY]-3, TITLE_Y, 11, 1, 6*3);
            DispStr(S_X[BATTERY], TITLE_Y, INV+SYMB, (u8*)&BT_S[3]);
          }
          else if(Tmp > V_BT[2]){
            SetColor(GRY, BT_C[2]);
            Draw_Circle_D(INV, S_X[BATTERY]-3, TITLE_Y, 11, 1, 6*3);
            DispStr(S_X[BATTERY], TITLE_Y, INV+SYMB, (u8*)&BT_S[2]);   
          }
          else if(Tmp > V_BT[1]){
            SetColor(GRY, BT_C[1]);
            Draw_Circle_D(INV, S_X[BATTERY]-3, TITLE_Y, 11, 1, 6*3);
            DispStr(S_X[BATTERY], TITLE_Y, INV+SYMB, (u8*)&BT_S[1]);   
          }
          else                  {
            SetColor(GRY, BT_C[0]);
            Draw_Circle_D(INV, S_X[BATTERY]-3, TITLE_Y, 11, 1, 6*3);
            DispStr(S_X[BATTERY], TITLE_Y, INV+SYMB, (u8*)&BT_S[0]);
          }
        }
        break;

      case SAVE_BMP: //ʾѡҪļ
      case SAVE_DAT:
      case SAVE_BUF:
      case SAVE_CSV:
      case SAVE_SVG:
      case LOAD_DAT: //ʾѡҪȡļ
      case LOAD_BUF:
        SetColor(GRY, TCOLOR[FN]);
        u8ToDec3(NumStr, List[i].Val);
        Draw_Circle_D(INV, S_X[i]-3, LABLE_Y, 11, 0, 6*11);
        DispStr(S_X[i],    LABLE_Y, INV, (u8*)((i > SAVE_SVG)? "Load" : "Save"));//0513
        DispStr(S_X[i]+24, LABLE_Y, INV, NumStr);
        DispStr(S_X[i]+42, LABLE_Y, INV, (u8*)(List[i].PTR +(i - SAVE_BMP)*6));
        break;
      case TPYE_OUT:
        if(List[TPYE_OUT].Val ==0) //suqar
        {
          __Ctrl(OUT_MOD, DISABLE);            // رģʽ
          Set_Fout(List[FREQ_OUT].Val);
          Set_Duty();
          __Ctrl(OUT_MOD, PULSED);             // 趨ģʽ
        }
        else
        {
          if(List[FREQ_OUT].Val > MAX_FREQ)
          {                                    //ģⲨ20KHz
             List[FREQ_OUT].Val = MAX_FREQ ;   //10KHz
          }
           __Ctrl(OUT_MOD, DISABLE);            // رģʽ 
           TIM_DA->PSC = Dac_Psc[List[FREQ_OUT].Val] - 1;
           __Ctrl(DAC_TIM, Dac_Tim[List[FREQ_OUT].Val]-1); // 72MHz/2/180/100 = 2KHz ģ(ÿ36)
           __Ctrl(OUT_CNT, 180);
           __Ctrl(OUT_BUF, __Info(List[TPYE_OUT].Val));    // ģҲݱ
           __Ctrl(OUT_MOD, ANALOG);             // 趨ģģʽ
        }
        
      break;
      
      case FREQ_OUT: // ʾƵ
        
        if(List[TPYE_OUT].Val ==0) //suqar
        {
          __Ctrl(OUT_MOD, DISABLE);            // رģʽ
          Set_Fout(List[FREQ_OUT].Val);
          Set_Duty();
          __Ctrl(OUT_MOD, PULSED);             // 趨ģʽ
        }
        else
        {
          if(List[FREQ_OUT].Val > MAX_FREQ)
          {                                    //ģⲨ20KHz
            List[FREQ_OUT].Val = MAX_FREQ ;   //10KHz
          }
          __Ctrl(OUT_MOD, DISABLE);            // رģʽ 
          TIM_DA->PSC = Dac_Psc[List[FREQ_OUT].Val] - 1;
          __Ctrl(DAC_TIM, Dac_Tim[List[FREQ_OUT].Val]-1); // 72MHz/2/180/100 = 2KHz ģ(ÿ36)
          __Ctrl(OUT_CNT, 180);
          __Ctrl(OUT_BUF, __Info(List[TPYE_OUT].Val));    // ģҲݱ
          __Ctrl(OUT_MOD, ANALOG);             // 趨ģģʽ
          
        }
        
        break;
       
      case FREQ_DUT: // ʾռձ
        //SetColor(GRY, TCOLOR[SN]);
        //Draw_Circle_D(INV, S_X[i]-3, LABLE_Y, 11, 0, 6*9);
        if(List[TPYE_OUT].Val == 0) //suqar
        {
          Set_Duty();
        }
        break;
        
      
      case EXT_REFN: // ʾο
      case EXT_POSI: // ʾοƫ
        SetColor(GRY, TCOLOR[EX]);
        if((i == EXT_REFN) || (i == EXT_POSI))
        {
          Draw_Circle_D(INV, S_X[EXT_REFN]-3, TITLE_Y, 11, 1, 6*5); 
          DispStr(S_X[EXT_REFN], TITLE_Y, INV, (List[EXT_HIDE].Val)? (u8*)(I[List[EXT_REFN].Val]) : (u8*)I[6]);
        }
        if(List[EXT_REFN].Val < 6) ParamTab[P2x2]=(List[EXT_POSI].Val + 1)*2;
        else                       ParamTab[P2x2]=(List[ V0_POSI].Val + 1)*2;
        break;

      case EXT_HIDE:
        if(List[EXT_HIDE].Val == 0) ParamTab[P2F] |=  W_HID;  // W_HIDο
        else                        ParamTab[P2F] &= ~W_HID;  // W_HIDʾο
        SetColor(GRY, TCOLOR[EX]);
        Draw_Circle_D(INV, S_X[EXT_REFN]-3, TITLE_Y, 11, 1, 6*5); 
        DispStr(S_X[EXT_REFN], TITLE_Y, INV, (List[EXT_HIDE].Val)? (u8*)(I[List[EXT_REFN].Val]) : (u8*)I[6]);
      break;
      
      case SYNCMODE:  // ˢʾͬģʽ
      case TR_MODE:   // ˢʾʽ
      case FITTRIGG:  // ˢʾԶֵ
      case THRESHOLD: // ˢʾֵ
      case SENSITIVE: // ˢʾ
      case TR_TYPE:   // ˢʾαʽ
        DispStatus();
        SetColor(GRY, TCOLOR[TR]);
        if(i == TR_MODE || i==SENSITIVE)
        {
          Draw_Circle_D(INV, S_X[TR_MODE]-3, TITLE_Y, 11, 0, 6*8);
          DispStr10x14(S_X[TR_MODE], TITLE_Y, INV+SYMB,(List[TR_MODE].Val?(u8*)("D"):(u8*)("C")));
        }
        if(i == FITTRIGG)
        {
          DispStr10x14(S_X[FITTRIGG], TITLE_Y, PRN+SYMB,(List[FITTRIGG].Val?(u8*)("F"):(u8*)("B")));
          if(List[FITTRIGG].Val)KEYTIME = 300;
          else KEYTIME = 0;
        }
        ParamTab[VTx2]= ParamTab[P1x2]+2*List[THRESHOLD].Val;
        Tmp  = List[SENSITIVE].Val;
        Tmp *= X_SCALE[Range]* Exp(V_SCALE[Range]);
        Value2Str(NumStr, Tmp, (u8*)V, 2, UNSIGN);
        DispStr10x14(S_X[SENSITIVE], TITLE_Y, INV+SYMB,"E");
        DispStr(S_X[SENSITIVE]+9, TITLE_Y, INV,  "     ");  
        DispStr(S_X[SENSITIVE]+9, TITLE_Y, INV,  NumStr);
        ParamTab[VTF]=(List[TR_TYPE].Val)? L_HID : SHOW;
        break;

      case TIM_BASE:  // ˢʾʱλ
      case VIEWPOSI:  // ˢʾˮƽӴλ
      case SMPL_DPTH: // ˢʾ
      case T1_POSI:   // ˢʾαλ
      case T2_POSI:   // ˢʾҶαλ
      case XN_TYPE:   // ˢʾαʽ
        SetColor(GRY, TCOLOR[XN]);                      
        if(i == TIM_BASE)
        { 
          Draw_Circle_D(INV, S_X[i]-3, TITLE_Y, 11, 2, 6*5);
          DispStr(S_X[i], TITLE_Y, INV, (u8*)TimeBase_Str[List[TIM_BASE].Val]);
        }       
        if(i == SMPL_DPTH){
          Draw_Circle_D(INV, S_X[SMPL_DPTH]-3, LABLE_Y, 11, 0, 6*11);
          DispStr(S_X[SMPL_DPTH],    LABLE_Y,  INV, "SmplDpth:  ");
          DispStr(S_X[SMPL_DPTH]+6*9, LABLE_Y,  INV, (u8*)&D[List[SMPL_DPTH].Val]);
        }
        Update_Windows();
        
        ParamTab[T0x1] = 2 + Presampling - List[VIEWPOSI].Val;
        ParamTab[T0F] &= ~D_HID;
        ParamTab[T1F] &= ~D_HID;
        ParamTab[T1F] &= ~D_HID;
        ParamTab[T1x1] = List[T1_POSI].Val+1;
        ParamTab[T2x1] = List[T2_POSI].Val+1;
        ParamTab[T1F]  = (List[XN_TYPE].Val)? L_HID : SHOW;
        ParamTab[T2F]  = (List[XN_TYPE].Val)? L_HID : SHOW;
        Tmp  = ParamTab[T2x1] - ParamTab[T1x1];
        Tmp *= B_SCALE[List[TIM_BASE].Val]* Exp(T_SCALE[List[TIM_BASE].Val]);
        Value2Str(NumStr, Tmp, (u8*)T, 3, UNSIGN);
        Draw_Circle_D(INV, S_X[V1_POSI]-3, LABLE_Y, 11, 0, 6*9);
        DispStr(S_X[T1_POSI]+0*6, LABLE_Y, INV+SYMB, "]");
        DispStr(S_X[T1_POSI]+1*6, LABLE_Y, INV,      "T:      ");
        DispStr(S_X[T1_POSI]+7*6, LABLE_Y, INV,  "  ");
        DispStr(S_X[T1_POSI]+3*6, LABLE_Y, INV,  NumStr);
        Set_Base(List[TIM_BASE].Val);          // Ӳɨʱλ
      break;
      case FREQUENC://ʾƵ
        FTmp=Edge*25*1000/2;
        if(List[TIM_BASE].Val<9)FTmp= FTmp*1000000;
        else if(List[TIM_BASE].Val<18)FTmp= FTmp*1000;
        FTmp=FTmp/Ts[List[TIM_BASE].Val]/DEPTH[List[SMPL_DPTH].Val];
          DispMeter(i, 1, UNSIGN,FTmp);
      break;        
      case DUTY:    //ʾռձ
         DispMeter(i, k, UNSIGN,(HighT*100)/k);
        break;
      case VRMS://ʾѹЧֵ
        if(fabs(Vrms)<4){
          Tmp = 0.00;
        }else{
		  scale = (List[PROBEATT].Val?
                  VScale_10X[List[Y_RANGES].Val]:VScale[List[Y_RANGES].Val])*40;
	          Tmp  = ((((Vrms)*Ak)>>12))*scale;
        }
        DispMeter(i, 1, UNSIGN, Tmp);
        break;
      case VP_P://ʾѹֵ
        if(fabs(Vpp)<7){
          Tmp = 0.00;
        }else{
           scale = (List[PROBEATT].Val?
                  VScale_10X[List[Y_RANGES].Val]:VScale[List[Y_RANGES].Val])*40;
          Tmp  = ((((Vmax-2048)*(Ak))>>12)-(((Vmin-2048)*(Ak))>>12))*scale;
        }
        DispMeter(i, 1, UNSIGN, Tmp);
        break;
      case VAVG://ʾѹƽֵ
        if(fabs(Vavg)<4){
          Tmp = 0.00;
        }else{
          scale = (List[PROBEATT].Val?
                  VScale_10X[List[Y_RANGES].Val]:VScale[List[Y_RANGES].Val])*40;
          Tmp = ((((Vavg-2048)*(Ak))>>12)+100-List[V0_POSI].Val)*scale;
        }
        DispMeter(i, 1, UNSIGN, Tmp);
        break;
      case VMAX://ʾѹֵ
        if(fabs(Vmax)<4){
          Tmp = 0.00;
        }else{
		  scale = (List[PROBEATT].Val?
                  VScale_10X[List[Y_RANGES].Val]:VScale[List[Y_RANGES].Val])*40;
          Tmp  = ((((Vmax-2048)*(Ak))>>12)+100-List[V0_POSI].Val)*scale;
        }
        DispMeter(i, 1, UNSIGN, Tmp);
        break;
      case VMIN://ʾѹСֵ
        if(fabs(Vmin)<4){
          Tmp = 0.00;
        }else{
		  scale = (List[PROBEATT].Val?
                           VScale_10X[List[Y_RANGES].Val]:VScale[List[Y_RANGES].Val])*40;
                  Tmp  = ((((Vmin-2048)*(Ak))>>12)+100-List[V0_POSI].Val)*scale;
        }
        DispMeter(i, 1, SIGN, Tmp);
        break;
      case STANDBY:
        
        break;
      case PWR_OFF:

        break;
        
      }
      /**/
      if(Freq_Flag){
        Freq_Flag = 0;
        FTmp=Edge*25*1000/2;
        if(List[TIM_BASE].Val<9)FTmp= FTmp*1000000;
        else if(List[TIM_BASE].Val<18)FTmp= FTmp*1000;
        FTmp=FTmp/Ts[List[TIM_BASE].Val]/DEPTH[List[SMPL_DPTH].Val];
        DispFreq(    1, UNSIGN,FTmp);
      }
    }
  }
    
}
/*******************************************************************************

*******************************************************************************/
void DispMeter(u8 Item, u8 St, u8 Mode, s32 Val)
{
  SetColor(GRY, TCOLOR[ME]);
  
  Draw_Circle_D(INV, S_X[Item]-3, LABLE_Y, 11, 0, 6*12);
  DispStr(S_X[Item], LABLE_Y, INV, (u8*)&Z[Item-FREQUENC]);// ʾĿ  
  Value2Str(NumStr, Val, List[Item].PTR, 3, Mode);
  
  if(St) {
    DispStr(S_X[Item]+24, LABLE_Y, INV, ":       ");  
    DispStr(S_X[Item]+30, LABLE_Y, INV, NumStr);   // ʾֵ+  
  }
  else   DispStr(S_X[Item]+24, LABLE_Y, INV, ": ----- ");   
}
/*******************************************************************************

*******************************************************************************/
void DispFreq(u8 St, u8 Mode, s32 Val)
{
  SetColor(GRY, TCOLOR[ME]);
  
  Draw_Circle_D(INV, S_X[FREQUENC]-6*15-3+4, LABLE_Y, 11, 0, 6*12);
  DispStr(S_X[FREQUENC]-6*15+4, LABLE_Y, INV, (u8*)&Z[0]);// ʾĿ  
  Value2Str(NumStr, Val, List[FREQUENC].PTR, 3, Mode);
  
  if(St) {
    DispStr(24+S_X[FREQUENC]-6*15+4, LABLE_Y, INV, ":       ");  
    DispStr(30+S_X[FREQUENC]-6*15+4, LABLE_Y, INV, NumStr);   // ʾֵ+  
  }
  else   DispStr(24+S_X[FREQUENC]-6*15+4, LABLE_Y, INV, ": ---- ");   
}
/*******************************************************************************

*******************************************************************************/
void DispStatus(void)
{
  u8* p;
  SetColor(GRY, (Status & STOP) ? RED : TCOLOR[TR]);
  p =(Status & STOP)?(u8*)M :(u8*)(List[SYNCMODE].PTR +(List[SYNCMODE].Val)*6); 
  Draw_Circle_D(INV, S_X[SYNCMODE]-3, TITLE_Y, 11, 1, 6*4);
  DispStr(S_X[SYNCMODE], TITLE_Y, INV, p);         
}
/*******************************************************************************

*******************************************************************************/
void ClrMeter(void)
{
  //DispStr(S_X[DUTY], LABLE_Y, PRN, "           ");
}
/*******************************************************************************

*******************************************************************************/
void ShowView(u16 Posi, u8 Dpth)
{
  u16 i, x0, Width, Depth = DEPTH[List[SMPL_DPTH].Val];

  DispStr( 68, LABLE_Y, SYMB, "IJJJJJJJJJJJJJJJJJJK"); // ȹ156
  Width = (156*300)/Depth;
  x0 = 71 + (156*List[VIEWPOSI].Val)/Depth;
  __Set_Posi(x0,         4); for (i=0; i<11; i++) __Set_Pixel(WHT);
  __Set_Posi(Width+x0-1, 4); for (i=0; i<11; i++) __Set_Pixel(WHT);
  for (i=x0+1; i<(Width+x0-1); i++){
    __Set_Posi(i,  3); __Set_Pixel(WHT);
    __Set_Posi(i, 15); __Set_Pixel(WHT);
  }
}

/*******************************************************************************

*******************************************************************************/
void DispFileInfo(u8 Info)
{ 
  SetColor(DAR, BLU);
  Draw_Circle_D(INV, S_X[SAVE_BMP]-3, LABLE_Y, 11, 0, 6*11);
  DispStr(S_X[SAVE_BMP], LABLE_Y, INV, ((u8*)&FnNote+14*Info));
  Delayms(2000);
  
}
/*******************************************************************************

*******************************************************************************/
void DispBMPInfo(void)
{ 
  SetColor(GRY, TCOLOR[FN]);
  u8ToDec3(NumStr, List[SAVE_BMP].Val);
  Draw_Circle_D(INV, S_X[SAVE_BMP]-3, LABLE_Y, 11, 0, 6*11);
  DispStr(S_X[SAVE_BMP],    LABLE_Y, INV, (u8*)("Save"));//0513
  DispStr(S_X[SAVE_BMP]+24, LABLE_Y, INV, NumStr);
  DispStr(S_X[SAVE_BMP]+42, LABLE_Y, INV, (u8*)(List[SAVE_BMP].PTR ));
}
/*******************************************************************************
Update_Proc_All  ȫˢ
*******************************************************************************/
void Update_Proc_All(void)
{
  u16 i;
  s_64 Tmp = 0;
  u8 Range = List[Y_RANGES].Val + 10*List[PROBEATT].Val;
  
  for(i=Y_RANGES; i<=BATTERY; i++){
    List[i].Flg |= UPD;
  }
  
  for(i=Y_RANGES; i<=BATTERY; i++){
    if(List[i].Flg & UPD){
      List[i].Flg &= ~UPD;
      switch (i){
      case Y_RANGES:   // ˢʾ Y ̵λ
      case PROBEATT:   // ˢʾ̽ͷ˥
      case COUPLING:   // ˢʾģʽ״̬
      case V0_POSI:    // ˢʾֱƫλ
        SetColor(GRY, TCOLOR[YN]);
        if(i == Y_RANGES || i == COUPLING||i == PROBEATT){
          Draw_Circle_D(INV, S_X[Y_RANGES]-3, TITLE_Y, 11, 0, 6*7);
          DispStr(S_X[Y_RANGES], TITLE_Y, INV,      (u8*)(List[Y_RANGES].PTR +(Range)*6));
          DispStr(S_X[COUPLING], TITLE_Y, INV,      (u8*)(List[COUPLING].PTR +(List[COUPLING].Val)*6));
          DispStr10x14(S_X[PROBEATT], TITLE_Y, PRN+SYMB,(List[PROBEATT].Val?(u8*)("A"):(u8*)("B")));
        }
        ParamTab[P1x2] = 2*((List[V0_POSI].Val+1));
        ParamTab[VTx2] = ParamTab[P1x2]+ 2*(List[THRESHOLD].Val+1);

        StateA =  ((u8)List[Y_RANGES].Val>5)?ACT: GND;                                    //ACT GND ӵػ򼤻״̬  
        GainA  = (u8)List[Y_RANGES].Val;  
        if((u8)List[Y_RANGES].Val>1)
          KindA  = HV;
        else   
          KindA  = LV;                //Ch1ѡѹѹ
        
        CouplA = (List[COUPLING].Val)? AC : DC;                      // AC);  //AC/DCϷʽ
        __Ctrl(AiRANGE, KindA+CouplA+StateA);             //Ch1״̬ˢ
        AiPosi(List[V0_POSI].Val);                        //Ch1ӲӦλ
        
        break;
      
      case SYNCMODE:  // ˢʾͬģʽ
      case TR_MODE:   // ˢʾʽ
      case FITTRIGG:  // ˢʾԶֵ
      case THRESHOLD: // ˢʾֵ
      case SENSITIVE: // ˢʾ
      case TR_TYPE:   // ˢʾαʽ
        DispStatus();
        SetColor(GRY, TCOLOR[TR]);
        if(i == TR_MODE || i==SENSITIVE)
        {
          Draw_Circle_D(INV, S_X[TR_MODE]-3, TITLE_Y, 11, 0, 6*8);
          DispStr10x14(S_X[TR_MODE], TITLE_Y, INV+SYMB,(List[TR_MODE].Val?(u8*)("D"):(u8*)("C")));
        }
        if(i == FITTRIGG)
        {
          DispStr10x14(S_X[FITTRIGG], TITLE_Y, PRN+SYMB,(List[FITTRIGG].Val?(u8*)("F"):(u8*)("B")));
          if(List[FITTRIGG].Val)KEYTIME = 300;
          else KEYTIME = 0;
        };
        ParamTab[VTx2]= ParamTab[P1x2]+2*List[THRESHOLD].Val;
        Tmp  = List[SENSITIVE].Val;
        Tmp *= X_SCALE[Range]* Exp(V_SCALE[Range]);
        Value2Str(NumStr, Tmp, (u8*)V, 2, UNSIGN);
        DispStr10x14(S_X[SENSITIVE], TITLE_Y, INV+SYMB,"E");
        DispStr(S_X[SENSITIVE]+9, TITLE_Y, INV,  "     ");  
        DispStr(S_X[SENSITIVE]+9, TITLE_Y, INV,  NumStr);
        ParamTab[VTF]=(List[TR_TYPE].Val)? L_HID : SHOW;
        break;

      case TIM_BASE:  // ˢʾʱλ
        SetColor(GRY, TCOLOR[XN]);                  
        if(i == TIM_BASE)
        {  
          Draw_Circle_D(INV, S_X[i]-3, TITLE_Y, 11, 2, 6*5);
          DispStr(S_X[i], TITLE_Y, INV, (u8*)TimeBase_Str[List[TIM_BASE].Val]);
        }       
        Set_Base(List[TIM_BASE].Val);          // Ӳɨʱλ
      break;
     
      }
    }
  }
}
/*******************************************************************************
»λ 
*******************************************************************************/
void Update_Windows(void)
{
  u16  x0,x,y,i,j,Width;
  u16  Depth =  DEPTH[List[SMPL_DPTH].Val];
  Width =(300*300)/Depth;
  if(Current == XN &&(PopType & LIST_POP) ){
      Windows_Pop = 1;
      x0=2+(List[VIEWPOSI].Val)*300/Depth;
      x=2;
      y=15;
      for(i=0;i<300;i++){    //
        __Set_Posi(x++, y);
        __Set_Pixel(DAR);
        for(j=0; j<2; j++)__Set_Pixel(RED);
        __Set_Pixel(DAR);     
      }
      if(Current == XN && (MenuNow[XN]==SMPL_DPTH )){  //Depthѡ
        if(Key_Buffer == KEYCODE_RIGHT || Key_Buffer == KEYCODE_LEFT){  //ѡб䶯ʱıԤλ
          List[VIEWPOSI].Val= 0;
          x0=2+(List[VIEWPOSI].Val)*300/Depth;
        }  
      }
      x = x0;               //ǰڻλ
      y=15;   
      for(i=0;i<Width;i++){
        __Set_Posi(x++, y);
        for(j=0; j<4; j++)__Set_Pixel(GRN);
      }
  }else if(Current == XN &&!(PopType & LIST_POP))
  {
    Windows_Pop = 0;
    Clr_WavePosi(DAR);
  }
  
}
/*******************************************************************************
 viod Clr_WavePosi(u16 Col)  λʾ
*******************************************************************************/
void Clr_WavePosi(u16 Col)
{
  u16 x,y,i,j;
  x=2;
  y=14;
  for(i=0;i<300;i++){
    __Set_Posi(x++, y);
    for(j=0; j<6; j++)__Set_Pixel(Col);
  } 
}
/******************************** END OF FILE *********************************/
